# ============================================================================
sub Get_FDfile
# ============================================================================
{
	local($file)=$_[0];
	local($count)=0;
	local($buf);
	local($pickup)="";
	
	if( -f $file ){
		open(IN,$file);
		while( ($buf=<IN>) ){
			($name)=split(/<>/,$buf);
			if( $pickup ne "" ){ $pickup.=","; }
			$pickup.=$name;
		}
		close(IN);
	}
	return($pickup);
}
# ============================================================================
sub Get_DBfile
# ============================================================================
{
	local($bname)=$_[0];
	local($file) =$_[1];
	local *IN;
	local($buf);
	local($smbl,$valu);
	local($code,$optn);
	local($www);
	
	tracesub("Get_DBfile:file=$file");
	clr_xvalue($bname);
	if( -f $file ){
#tracesub("----- Get_DBfile FOUND:$file -----");
		open(IN,"$file");
		while( ($buf=<IN>) ){
			$buf =~ s/\n//g;
			$buf =~ s/\xd//g;
			if( substr($buf,0,1) eq '/' ){
				($code,$optn)=split(/:/,$buf);
				$www = "";
				while( ($buf=<IN>) ){
					$buf =~ s/\n//g;
					$buf =~ s/\xd//g;
					if( $buf eq "/END" ){ last; }
					if( $www ne "" ){ $www .= "<cr>"; }
					$www .= substr($buf,1);
				}
				$code = substr($code,1);
#tracesub("Get_DBfile bname=$bname code=$code val=$www");
				put_xvalue($bname,$code,$www,"");
			}
		}
		close(IN);
		return(1);
	}
	else{
		tracesub("----- Get_DBfile UNDEFINED:$file -----");
	}
	return(0);
}
# ============================================================================
sub Put_DBfile
# ============================================================================
{
	local($bname)=$_[0];
	local($file) =$_[1];
	local *OT;
	local(@io_bufx);
	local($i);
	local($code,$value);
	local($cnt);

tracesub("Put_DBfile:bname=$bname file=$file ");
	if( filelock($file)==0 ){
tracesub("Put_DBfile:file lock error file=$file ");
		return(0);
	}
	$cnt = get_xcnt($bname);
#tracesub("Put_DBfile:bname=$bname cnt=$cnt file=$file ");
	open(OT,">$file");
	for($i=0;$i<$cnt;$i++){
		$code =get_xsimbol($bname,$i);
		print OT "\/$code:\n";
		$value=get_xvalue($bname,$code);
		@io_bufx=split(/<cr>/,$value);
#tracesub("Put_DBfile:$i code=$code value=$value splitc(line count)=".@io_bufx);
		foreach(@io_bufx){
			print OT " $_\n";
		}
		print OT "/END\n";
	}
	close(OT);

#tracesub("Put_DBfile:close");
	
	fileunlock($file);

#tracesub("Put_DBfile:return");
	
	return(1);
}
# ============================================================================
sub filelock 
# ============================================================================
{
	local($lock_file_target)=$_[0];
	local($tmpflag);
	local($lock_file);
	local($xdir,$xfil,$xext);
	
	($xdir,$xfil,$xext)=fnsplit($lock_file_target);
	$lock_file = $xdir."lock_".$xfil."_lock".$xext;
	
#tracesub("filelock lockfile=$lock_file");
	
	foreach (1 .. 10) {
		unless (-f $lock_file) { $tmpflag = 1; last; }
		$tmpflag = 0;
		sleep(1);
	}
	if ($tmpflag == 1) {
		if (!open(LOCK,">$lock_file")) { 
			#&error("bNt@C쐬ł܂łB"); 
			tracesub("ERROR bNt@C쐬ł܂łB($lock_file)");
			return(0);
		}
		close(LOCK);
		return(1);
	} elsif ($tmpflag == 0) { 
		#&error("GĂ܂BԂčēxsĂB"); 
		tracesub("ERROR GĂ܂BԂčēxsĂB");
		return(0);
	}
	return(1);
}
# ============================================================================
sub fileunlock 
# ============================================================================
{
	local($lock_file_target)=$_[0];
	local($lock_file);
	local($xdir,$xfil,$xext);
	
	($xdir,$xfil,$xext)=fnsplit($lock_file_target);
	$lock_file = $xdir."lock_".$xfil."_lock".$xext;
	if (-f $lock_file) { unlink $lock_file; }
}
# ============================================================================
sub lock #($file_name, $use_lock)
# ============================================================================
{
	local($file_name, $use_lock) = @_;
	local($lock_flag) = $file_name . ".lock";

	if ($use_lock) {
		local($i) = 0;
#		return -1 if (!-f $file_name);
		rmdir($lock_flag) if (-d $lock_flag && time - (stat($lock_flag))[9] > 60);
		while(!mkdir($lock_flag, 0755)) {
			select(undef, undef, undef, 0.05);
			return 0 if (++ $i >= 100);
		}
		return 1;
 	}
 	return 1;
}
# ============================================================================
sub unlock
# ============================================================================
{
	rmdir("$_[0].lock") if (-d "$_[0].lock");
}
# ============================================================================
sub get_exvalue
# ============================================================================
{
	local($bname)=$_[0];
	local($flds )=$_[1];
	local($p);
	local($smbl_valu);
	local($smbl_grop);
	local($v);
	
	
#tracesub("get_exvalue bname=$bname flds=$flds");
	if( $bname eq "" && $flds eq "" ){
		return("");
		
	}elsif( $bname eq "" || $flds eq "" ){
		if( $bname eq "" ){
			@get_exvalue_lst=split(/\|/,$flds);
		}else{
			@get_exvalue_lst=split(/\|/,$bname);
		}
		foreach(@get_exvalue_lst){
			if( $_=~/^\'/ && $_=~/\'$/ ){
				$_=~s/^\'//g;
				$_=~s/\'$//g;
				return($_);
			}
			$smbl_valu = $_;
			$p = index($smbl_valu,"_");
			if( $p!=-1 ){
				$smbl_grop = substr($smbl_valu,0,$p);
				$v = get_xvalue($smbl_grop,$smbl_valu);
				if( $v=~/^\'/ && $v=~/\'$/ ){
					$v=~s/^\'//g;
					$v=~s/\'$//g;
				}
				if( $v ne "" ){
					return($v);
				}
			}
		}
	}else{
		$flds = j_repl($flds,"|","||");
#tracesub("get_exvalue conv flds=$flds");
		@get_exvalue_lst=split(/\|\|/,$flds);
		foreach(@get_exvalue_lst){
#tracesub("get_exvalue tok=$_");
			if( $_=~/^\'/ && $_=~/\'$/ ){
				$_=~s/^\'//g;
				$_=~s/\'$//g;
#tracesub("get_exvalue string=$_");
				return($_);
			}
			$v = get_xvalue($bname,$_);
			if( $v ne "" ){
#tracesub("get_exvalue value=$_");
				return($v);
			}
		}
	}
	return("");
}
# ============================================================================
sub clr_xvalue
# ============================================================================
{
	local($bname)=$_[0];
	local($i,$n);
	
#tracesub("clr_xvalue");
	
	if( $bname eq "fldv" ){
		for($i=0;$i<$fldc;$i++){
			$n = $fldn{$i};
			$fldv{$n} = "";
			$fldn{$i} = "";
		}
		$fldc=0;
	}elsif( $bname eq "argv" ){
		for($i=0;$i<$argc;$i++){
			$n = $argn{$i};
			$argv{$n} = "";
			$argn{$i} = "";
		}
		$argc=0;
	}elsif( $bname eq "fdfv" ){
		for($i=0;$i<$fdfc;$i++){
			$n = $fdfn{$i};
			$fdfv{$n} = "";
			$fdfn{$i} = "";
		}
		$fdfc=0;
	}elsif( $bname eq "fdsv" ){
		for($i=0;$i<$fdsc;$i++){
			$n = $fdsn{$i};
			$fdsv{$n} = "";
			$fdsn{$i} = "";
		}
		$fdsc=0;
	}elsif( $bname eq "fdbv" ){
		for($i=0;$i<$fdbc;$i++){
			$n = $fdbn{$i};
			$fdbv{$n} = "";
			$fdbn{$i} = "";
		}
		$fdbc=0;
	}elsif( $bname eq "datv" ){
		for($i=0;$i<$datc;$i++){
			$n = $datn{$i};
			$datv{$n} = "";
			$datn{$i} = "";
		}
		$datc=0;
	}elsif( $bname eq "msPv" ){
		for($i=0;$i<$msPc;$i++){
			$n = $msPn{$i};
			$msPv{$n} = "";
			$msPn{$i} = "";
		}
		$msPc=0;
	}elsif( $bname eq "msAv" ){
		for($i=0;$i<$msAc;$i++){
			$n = $msAn{$i};
			$msAv{$n} = "";
			$msAn{$i} = "";
		}
		$msAc=0;
	}elsif( $bname eq "msSv" ){
		for($i=0;$i<$msSc;$i++){
			$n = $msSn{$i};
			$msSv{$n} = "";
			$msSn{$i} = "";
		}
		$msSc=0;
	}elsif( $bname eq "msHv" ){
		for($i=0;$i<$msHc;$i++){
			$n = $msHn{$i};
			$msHv{$n} = "";
			$msHn{$i} = "";
		}
		$msHc=0;
	}else{
		for($i=0;$i<$gdat{$bname."_cnt"};$i++){
			$n = $gdat{$bname."_n".$i};
			$gdat{$bname."_v".$n} = "";
			$gdat{$bname."_n".$i} = "";
		}
		$gdat{$bname."_cnt"}=0;
	}

}
# ============================================================================
sub chk_simbol
# ============================================================================
{
	local($bname)=$_[0];
	local($simbl)=$_[1];
	local($i);
	
	if( $bname eq "fldv" ){
		for($i=0;$i<$fldc;$i++){
			if( $fldn{$i} eq $simbl ){
				return($i);
			}
		}
	}elsif( $bname eq "argv" ){
		for($i=0;$i<$argc;$i++){
			if( $argn{$i} eq $simbl ){
				return($i);
			}
		}
	}elsif( $bname eq "fdfv" ){
		for($i=0;$i<$fdfc;$i++){
			if( $fdfn{$i} eq $simbl ){
				return($i);
			}
		}
	}elsif( $bname eq "fdsv" ){
		for($i=0;$i<$fdsc;$i++){
			if( $fdsn{$i} eq $simbl ){
				return($i);
			}
		}
	}elsif( $bname eq "fdbv" ){
		for($i=0;$i<$fdbc;$i++){
			if( $fdbn{$i} eq $simbl ){
				return($i);
			}
		}
	}elsif( $bname eq "datv" ){
		for($i=0;$i<$datc;$i++){
			if( $datn{$i} eq $simbl ){
				return($i);
			}
		}
	}elsif( $bname eq "msPv" ){
		for($i=0;$i<$msPc;$i++){
			if( $msPn{$i} eq $simbl ){
				return($i);
			}
		}
	}elsif( $bname eq "msAv" ){
		for($i=0;$i<$msAc;$i++){
			if( $msAn{$i} eq $simbl ){
				return($i);
			}
		}
	}elsif( $bname eq "msSv" ){
		for($i=0;$i<$msSc;$i++){
			if( $msSn{$i} eq $simbl ){
				return($i);
			}
		}
	}elsif( $bname eq "msHv" ){
		for($i=0;$i<$msHc;$i++){
			if( $msHn{$i} eq $simbl ){
				return($i);
			}
		}
	}else{
		for($i=0;$i<$gdat{$bname."_cnt"};$i++){
			if( $gdat{$bname."_n".$i} eq $simbl ){
				return($i);
			}
		}
	}
	return(-1);
}
# ============================================================================
sub put_xvalue
# ============================================================================
{
	local($bname)=$_[0];
	local($simbl)=$_[1];
	local($value)=$_[2];
	local($opti) =$_[3];
	local($snap) =$_[4];
	local($n);
	
#tracesub("put_xvalue;bname=$bname simbl=$smbl value=$value");
	
	if( $bname eq "fldv" ){
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $fldc;
			if($n eq ""){
				$n=0;
				$fldc=0;
			}
			$fldc++;
		}
#tracesub("put_xvalue;FLDV simbl=$simbl value=$value TO n=$n ");
		$fldn{$n}     = $simbl;
		$fldv{$simbl} = $value;
	}elsif( $bname eq "argv" ){
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $argc;
			if($n eq ""){
				$n=0;
				$argc=0;
			}
			$argc++;
		}
		$argn{$n}     = $simbl;
		$argv{$simbl} = $value;
	}elsif( $bname eq "fdfv" ){
#tracesub("put_xvalue;FDFV bname=$bname simbl=$smbl value=$value");
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $fdfc;
			if($n eq ""){
				$n=0;
				$fdfc=0;
			}
			$fdfc++;
		}
		$fdfn{$n}     = $simbl;
		$fdfv{$simbl} = $value;
	}elsif( $bname eq "fdsv" ){
#tracesub("put_xvalue;FDFV bname=$bname simbl=$smbl value=$value");
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $fdsc;
			if($n eq ""){
				$n=0;
				$fdsc=0;
			}
			$fdsc++;
		}
		$fdsn{$n}     = $simbl;
		$fdsv{$simbl} = $value;
	}elsif( $bname eq "fdbv" ){
#tracesub("put_xvalue;FDBV bname=$bname simbl=$smbl value=$value");
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $fdbc;
			if($n eq ""){
				$n=0;
				$fdbc=0;
			}
			$fdbc++;
		}
		$fdbn{$n}     = $simbl;
		$fdbv{$simbl} = $value;
	}elsif( $bname eq "datv" ){
		$n = chk_simbol($bname,$simbl);
#tracesub("put_xvalue;DATV simbl=$simbl value=$value TO n=$n ");
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $datc;
			if($n eq ""){
				$n=0;
				$datc=0;
			}
			$datc++;
		}
		$datn{$n}     = $simbl;
		$datv{$simbl} = $value;
	}elsif( $bname eq "msPv" ){
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $msPc;
			if($n eq ""){
				$n=0;
				$msPc=0;
			}
			$msPc++;
		}
		$msPn{$n}     = $simbl;
		$msPv{$simbl} = $value;
	}elsif( $bname eq "msAv" ){
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $msAc;
			if($n eq ""){
				$n=0;
				$msAc=0;
			}
			$msAc++;
		}
		$msAn{$n}     = $simbl;
		$msAv{$simbl} = $value;
	}elsif( $bname eq "msSv" ){
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $msSc;
			if($n eq ""){
				$n=0;
				$msSc=0;
			}
			$msSc++;
		}
		$msSn{$n}     = $simbl;
		$msSv{$simbl} = $value;
	}elsif( $bname eq "msHv" ){
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $msHc;
			if($n eq ""){
				$n=0;
				$msHc=0;
			}
			$msHc++;
		}
		$msHn{$n}     = $simbl;
		$msHv{$simbl} = $value;
	}else{
#tracesub("put_xvalue;USER bname=$bname simbl=$simbl value=$value");
		$n = chk_simbol($bname,$simbl);
		if( $n==-1 ){
			if( $opti eq "edt" ){
				return;
			}
			$n = $gdat{$bname."_cnt"};
			if($n eq ""){
				$n=0;
				$gdat{$bname."_cnt"}=0;
			}
			$gdat{$bname."_cnt"}++;
		}
		if( $snap==1 ){
			tracesub("n=$n simbol=($bname"."_n".$n.")");
		}
		$gdat{$bname."_n".$n    } = $simbl;
		$gdat{$bname."_v".$simbl} = $value;
	}
}
# ============================================================================
sub snap_xvalue
# ============================================================================
{
	local($bname)=$_[0];
	local($i);
	local($ret)="";
	local($n,$v);
	
	for($i=0;$i<$gdat{$bname."_cnt"};$i++){
		$n = $gdat{$bname."_n".$i};
		$v = $gdat{$bname."_v".$n};
		if( $ret ne "" ){ $ret.="<cr>"; }
		$ret.="$n=$v";
	}
	return($ret);
}
# ============================================================================
sub get_xcnt
# ============================================================================
{
	local($bname)=$_[0];
	
	if( $bname eq "fldv" ){
		return( $fldc );
	}elsif( $bname eq "argv" ){
		return( $argc );
	}elsif( $bname eq "fdfv" ){
		return( $fdfc );
	}elsif( $bname eq "fdsv" ){
		return( $fdsc );
	}elsif( $bname eq "fdbv" ){
		return( $fdbc );
	}elsif( $bname eq "datv" ){
		return( $datc );
	}elsif( $bname eq "msPv" ){
		return( $msPc );
	}elsif( $bname eq "msAv" ){
		return( $msAc );
	}elsif( $bname eq "msSv" ){
		return( $msSc );
	}elsif( $bname eq "msHv" ){
		return( $msHc );
	}else{
		return( $gdat{$bname."_cnt"} );
	}
	return("");
}
# ============================================================================
sub get_xsimbol
# ============================================================================
{
	local($bname)=$_[0];
	local($simbl)=$_[1];
	local($xrec,$xrow,$xcol,$xsbl);
	
#tracesub("get_xsimbol:bname=$bname simbol=$simbl");
	
	if( $bname eq "fldv" ){
		return( $fldn{$simbl} );
	}elsif( $bname eq "fldv_tbl" ){
		($xrec,$xrow,$xcol,$xsbl)=field_dimdecord($simbl);
		$simbl=field_dimencord($xsbl,$xcol,$xrow,"");
		return( $fldn{$simbl} );
	}elsif( $bname eq "argv" ){
		return( $argn{$simbl} );
	}elsif( $bname eq "fdfv" ){
		return( $fdfn{$simbl} );
	}elsif( $bname eq "fdsv" ){
		return( $fdsn{$simbl} );
	}elsif( $bname eq "fdbv" ){
		return( $fdbn{$simbl} );
	}elsif( $bname eq "datv" ){
		return( $datn{$simbl} );
	}elsif( $bname eq "msPv" ){
		return( $msPn{$simbl} );
	}elsif( $bname eq "msAv" ){
		return( $msAn{$simbl} );
	}elsif( $bname eq "msSv" ){
		return( $msSn{$simbl} );
	}elsif( $bname eq "msHv" ){
		return( $msHn{$simbl} );
	}else{
#tracesub("get_xvalue;USER bname=$bname simbl=$smbl");
		return( $gdat{$bname."_n".$simbl} );
	}
	return("");
}
# ============================================================================
sub get_xvalue
# ============================================================================
{
	local($bname)=$_[0];
	local($simbl)=$_[1];
	local($cnv_val);
	local($p);
#tracesub("get_xvalue bname=$bname simbol=$simbl");
	
	if( $simbl eq "" ){
		$cnv_val = $bname;
	}
	else{
		$cnv_val = $simbl;
	}
	if( substr($cnv_val,0,1) eq "\'" ){
		$cnv_val=substr($cnv_val,1);
		$cnv_val=substr($cnv_val,0,length($cnv_val)-1);
		return($cnv_val);
	}
	if( $bname eq "fldv" ){
		return( $fldv{$simbl} );
	}elsif( $bname eq "argv" ){
		return( $argv{$simbl} );
	}elsif( $bname eq "fdfv" ){
		return( $fdfv{$simbl} );
	}elsif( $bname eq "fdsv" ){
		return( $fdsv{$simbl} );
	}elsif( $bname eq "fdbv" ){
		return( $fdbv{$simbl} );
	}elsif( $bname eq "datv" ){
		return( $datv{$simbl} );
	}elsif( $bname eq "msPv" ){
		return( $msPv{$simbl} );
	}elsif( $bname eq "msAv" ){
		return( $msAv{$simbl} );
	}elsif( $bname eq "msSv" ){
		return( $msSv{$simbl} );
	}elsif( $bname eq "msHv" ){
		return( $msHv{$simbl} );
	}else{
		if( $simbl eq "" ){
			$p=index($bname,"_");
			if( $p!=-1 ){
				$simbl=$bname;
				$bname=substr($simbl,0,$p);
			}
		}
		return( $gdat{$bname."_v".$simbl} );
	}
	return("");
}
# ============================================================================
sub get_fieldnamelists
# ============================================================================
{
	local($dir)      =$_[0];
	local($file_athd)=$_[1];
	#---------------------------------------------------------------------------
	local($fld_at)="get_fieldnamelists_temp";
	local($filedeff);
	local($fileno  );
	local($flddef_count);
	local($i);
	local($field_defname);
	local($field_name   );
	local($pickup_field)="";
	#---------------------------------------------------------------------------
	# GET FIELD
	#---------------------------------------------------------------------------
	clr_xvalue($fld_at);
	$filedeff = $dir."zp_".$file_athd."_flddef.cgi";
	($fileno)=get_file_attr($fld_at,$filedeff);
	$flddef_count = get_xvalue($fld_at,"block_fieldlist_line");
	
	$pickup_field="";
	for($i=0;$i<$flddef_count;$i++){
		$field_defname = "block_fieldlist_".$i;
		$field_name    = get_xvalue($fld_at,$field_defname."_fieldname");
		if( $pickup_field ne "" ){ $pickup_field.=","; }
		$pickup_field.=$field_name;
	}
	return($pickup_field);
}
# ============================================================================
sub get_file_attr
# ============================================================================
{
	local($bname)=$_[0];
	local($file) =$_[1];
	local *IN;
	local($fieldname);
	local($s)=0;
	local($buf);
	local($sw)=0;
	
	clr_xvalue($bname);
	tracesub("get_file_attr:file=$file");
	if( -f $file ){
		open(IN,$file);
		while( ($buf=<IN>) ){
			$buf=~s/\n//g;
			$buf=~s/\xd//g;
			if( $buf=~/^\<block\>/ ){
				$sw=1;
			}else{
				if( $sw==1 ){
					if( $buf=~/^\<\/block\>/ ){
						last;
					}
					if( $buf ne "" ){
						($fieldname)=split(/<>/,$buf);
						put_xvalue($bname,"block_fieldlist_".$s."_fieldname",$fieldname);
						$s++;
					}
				}
			}
		}
		close(IN);
	}
#tracesub("get_file_attr:buf=$buf");
	put_xvalue($bname,"block_fieldlist_line",$s);
	
}
# ============================================================================
sub get_file_attr_old
# ============================================================================
{
	local($bname)=$_[0];
	local($file) =$_[1];
	local *IN;
	local($buf);
	local($smbl,$valu);
	local($c,$mx,$s,$p);
	local($field_count)=0;
	local($flddef_count);
	local($i);
	local($field_defname);
	local($field_name);

	tracesub("get_file_attr:file=$file");

	if( -f $file ){
		#------------------------
		# FIELD DEFINE
		#------------------------
		$fattrc = 0;
		$fattrname[$fattrc]="fieldname";		$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="fieldcall";		$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="blockname";		$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="mainkey";			$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="type";				$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="option";			$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="nullcheck";		$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="displayformat";	$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="align";			$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="width";			$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="height";			$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="edtusr";			$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;
		$fattrname[$fattrc]="lokusr";			$fattrnumb{$fattrname[$fattrc]}=$fattrc;	$fattrc++;

		open(IN,$file);
		while( ($buf=<IN>) ){
			$buf=~s/\n//g;
			$buf=~s/\xd//g;
#tracesub("get_file_attr:buf=$buf");
			if(     substr($buf,0,1) eq "#" ){
			}elsif( $buf eq "<fileattr>"    ){
				while( ($buf=<IN>) ){
					$buf=~s/\n//g;
					$buf=~s/\xd//g;
					if( $buf eq "</fileattr>"){
						last;
					}elsif( substr($buf,0,1) eq "#" ){
					}else{
						$c = index($buf,":");
						if( $c!=-1 ){
							$smbl=substr($buf,0,$c);
							$smbl=~s/^\s+//g;
							$smbl=~s/\s+$//g;
							$smbl=~s/^A\_//g;
							$smbl="A_".$smbl;
							$valu=substr($buf,$c+1);
							if( $valu eq "<list\?>" ){
								$valu = "";
								while( ($buf=<IN>) ){
									$buf=~s/\n//g;
									$buf=~s/\xd//g;
									if( $buf eq "end"){
										last;
									}
									if( $valu ne "" ){ $valu.="<cr>"; }
									$valu.= substr($buf,1);
								}
							}
							put_xvalue($bname,$smbl,$valu);
						}
					}
				}
			}elsif( index($buf,":")!=-1    ){
#tracesub("get_file_attr:CORON FOUND");
				$p = index($buf,":");
#tracesub("get_file_attr:CORON FOUND p=$p");
				if( $p!=-1 ){
					$smbl=substr($buf,0,$p);
					$smbl=~s/^\s+//g;
					$smbl=~s/\s+$//g;
					$valu=substr($buf,$p+1);
				}
				if( $valu eq "<list\?>" ){
					$valu = "";
					while( ($buf=<IN>) ){
						$buf=~s/\n//g;
						$buf=~s/\xd//g;
						if( $buf eq "end"){
							last;
						}
						if( $valu ne "" ){ $valu.="<cr>"; }
						$valu.= substr($buf,1);
					}
					put_xvalue($bname,$smbl,$valu);
					
				}elsif( $smbl eq "<block>" ){
					$c=0;
					$mx=0;
					$smbl = "block_".$valu;
					while( ($buf=<IN>) ){
						$buf=~s/\n//g;
						$buf=~s/\xd//g;
						$buf =~s/^\s+//g;
						$buf =~s/\s+$//g;
#tracesub("get_file_attr:BLOCK=$buf");
						if( $buf eq "</block>"){
							last;
						}
						$s = 0;
						@block_list=split(/<>/,$buf);
						foreach(@block_list){
							$buf = $_;
							$buf =~s/^\s+//g;
							$buf =~s/\s+$//g;
#tracesub("get_file_attr:BLOCK PUT XVALUE($buf) bname=$bname smbl=$smbl attr=$fattrname[$s]");
							put_xvalue($bname,$smbl."_".$c."_".$fattrname[$s],$buf);
							$s++;
							if( $mx<$s ){ $mx = $s; }
							
						}
						$c++;
					}
					put_xvalue($bname,$smbl,$mx);
					put_xvalue($bname,$smbl."_line",$c);
					put_xvalue($bname,$smbl."_colm",$mx);
					
				}else{
					put_xvalue($bname,$smbl,$valu);
				}
			}else{
				$s=0;
				@block_list=split(/<>/,$buf);
				foreach(@block_list){
					$buf = $_;
					$buf =~s/^\s+//g;
					$buf =~s/\s+$//g;
					$ss[$s] = $buf;
					$s++;
				}
				$blk = $ss[ $fattrnumb{'blockname'} ];
				$nam = $ss[ $fattrnumb{'fieldname'} ];
				$blk =~s/^\s+//g;
				$blk =~s/\s+$//g;
				$nam =~s/^\s+//g;
				$nam =~s/\s+$//g;
				$smbl = "";
				$smbl.= $blk;
				if( $smbl ne "" ){ $smbl .= "_"; }
				$smbl.= $nam;
				for($c=0;$c<$s;$c++){
					put_xvalue($bname,$smbl."_".$fattrname[$c],$ss[$c]);
				}
			}
		}
		close(IN);
		
		#$flddef_count = get_xvalue($bname,"block_fieldlist_line");
		#for($i=0;$i<$flddef_count;$i++){
		#	$field_defname = "block_fieldlist_".$i;
		#	$field_name    = get_xvalue($bname,$field_defname."_fieldname");
		#	if( get_xvalue($bname,$field_defname."_type") eq "xarea" ){
		#		fck_edit_fldpush($field_name);
		#	}
		#}
#		tracesub("get_file_attr NORMAL END:file=$file fileno=$fileno ");
		return($fileno);
	}
	tracesub("get_file_attr ABEND:file=$file ");
#	return(-1);
}
# ============================================================================
sub get_datacount
# ============================================================================
{
	local($path)     =$_[0];
	local($head)     =$_[1];
	local($bname)    =$_[2];
	local($sort_key) =$_[3];
	local($sort_typ) =$_[4];
	local($sub_field)=$_[5];
	local($null_val) =$_[6];
	local($count)=0;
	local($dir);
	local($file);
	local($key,$name);
	local($dirlist);
	
	#tracesub("get_datacount");
	
	$dir=$path;
	opendir($dirlist,"$dir");
	while($file = readdir($dirlist)){
		if($file =~ /\.cgi/i && $file ne ".cgi" ){
			if( $file=~/^$head/ ){
				$key ="";
				$name="";
				if( $sort_key ne "" ){
					Get_DBfile($bname,"$dir$file");
					$key=get_xvalue($bname,$sort_key);
					if( $key eq "" ){ 
						if( $null_val ne "" ){
							$key = $null_val; 
						}
						else{
							$key = "999999"; 
						}
					}
					$names="";
					if( $sub_field ne "" ){
						@sub_fields=split(/,/,$sub_field);
						foreach(@sub_fields){
							if( $names ne "" ){ $names.="<cr>"; }
							$names.=get_xvalue($bname,$_);
						}
						$names.="<>";
					}
				}
				$exdata[$count] = "$key<>$dir$file<>$names";
				$count++;
			}
		}
	}
	closedir($dirlist);
	if( $sort_typ=~/NOSORT/i ){
	}else{
		if( substr($sort_typ,0,1) eq "n" ){
			if( index($sort_typ,"ds")!=-1 ){
				@exdata = sort {$b <=> $a} @exdata;
			}
			else{
				@exdata = sort {$a <=> $b} @exdata;
			}
		}else{
			if( index($sort_typ,"ds")!=-1 ){
				@exdata = sort {$b cmp $a} @exdata;
			}
			else{
				@exdata = sort @exdata;
			}
		}
	}
	return($count);
}
# ============================================================================
sub gselect_files
# ============================================================================
{
	local($dir)     =$_[0];
	local($filehead)=$_[1];
	local($lname)   =$_[2];
	local($sort_key)=$_[3];
	local($sort_typ)=$_[4];
	local($fild_add)=$_[5];
	local($null_val)=$_[6];
	local($extractD)=$_[7];
	local($bname)   =$_[8];
	local($file);
	local($i,$j);
	local($key);
	
	local($smbl,$frmt);
	local($xdir,$xfil,$xext);
	local($xpfilw);
	
	local($chk_cnt);
	local(@chk_dec);
	local(@chk_mrk);
	local($chk_val_0);
	local($chk_val_1);
	local($chk_decv);
	local($cmp);
	local($i);
	local($extracts);

	local($wrt);
	local($select_file_count);
	local($select_files_max_no);
	local($fild_val);
	#------------------------------------------------------
	# ex.$extracts
	#
	# $extracts = "ITEM_GROP".".eq.\'".$grop_name."\'";
	#
	#------------------------------------------------------
	if( $bname eq "" ){
		$bname = "gseltmp";
	}
	tracesub("gselect_files:dir=$dir filehead=$filehead");
	#------------------------------------------------------
	$select_file_count=0;
	$select_files_max_no= -1;
	@gselstk=();
	clr_xvalue($lname);
	clr_xvalue($bname);
	#------------------------------------------------------
	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if($file =~ /\.cgi$/i && $file ne ".cgi" ){
			if( $file=~/^$filehead/ ){
				($xpdir,$xpfil,$xpext)=fnsplit($file);
				$xpfilw=$xpfil;
				$xpfilw=~s/^$filehead//g;
				if( $xpfilw>=$select_files_max_no ){
					$select_files_max_no = $xpfilw+1;
				}

				$key="";
				Get_DBfile($bname,"$dir$file");
				if( $sort_key ne "" ){
					$key_lst="";
					@sort_keys = split(/,/,$sort_key);
					foreach(@sort_keys){
						($smbl,$frmt)=split(/\|/,$_);
						if( $_ eq '%NO' ){
							$key = $xpfilw;
						}
						else{
							$key=get_xvalue($bname,$smbl);
						}
						if( $key eq ""  ){ 
							if( $null_val ne "" ){
								$key = "$null_val"; 
							}
							else{
								$key = "999999"; 
							}
						}
						if( $frmt ne "" ){
							$key = sprintf($frmt,$key);
						}
						$key_lst.=$key;
					}
					$key = $key_lst;
				}
				@select_files_field=split(/,/,$fild_add);
				$fild_val="";
				foreach(@select_files_field){
					$fild_val.=get_xvalue($bname,$_)."<>";
				}
				$wrt=1;
				if( $extractD ne "" ){
					local($decd_flag) = 0;
					@extractD_stk=split(/\|\|/,$extractD);
					foreach(@extractD_stk){
						$extracts=$_;
						$chk_cnt=0;
						@extracts_stk=split(/,/,$extracts);
						foreach(@extracts_stk){
							# VAL0.cmp.VAL1,and.VAL2.cmp.VAL3
							if( $chk_cnt==0 ){
								($chk_val_0,$cmp,$chk_val_1,$nxp)=
									operation_split($_);
							}
							else{
								($chk_mrk[$chk_cnt],$chk_val_0,$cmp,$chk_val_1,$nxp)=
									operation_split($_);
							}
							$chk_val_0 = get_exvalue($bname,$chk_val_0);
							$chk_val_1 = get_exvalue($bname,$chk_val_1);
							$chk_dec[$chk_cnt]=0;
							if( $cmp eq "==" ){
								if( $chk_val_0 == $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "<=" ){
								if( $chk_val_0 <= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq ">=" ){
								if( $chk_val_0 >= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "<"  ){
								if( $chk_val_0 <  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq ">"  ){
								if( $chk_val_0 >  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "!=" ){
								if( $chk_val_0 != $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "eq" ){
								if( $chk_val_0 eq $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "le" ){
								if( $chk_val_0 le $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "ge" ){
								if( $chk_val_0 ge $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "lt" ){
								if( $chk_val_0 lt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "gt" ){
								if( $chk_val_0 gt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "ne" ){
								if( $chk_val_0 ne $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							$chk_cnt++;
						}
						$chk_decv=$chk_dec[0];
						for($i=1;$i<$chk_cnt;$i++){
							if( $chk_mrk[$i] eq "" || $chk_mrk[$i] eq "and" ){
								$chk_decv*=$chk_dec[$i];
							}else{
								$chk_decv+=$chk_dec[$i];
								if( $chk_decv!=0 ){
									$chk_decv=1;
								}
							}
						}
						if( $chk_decv!=0 ){
							$decd_flag+=1;
						}
					}
					if( $decd_flag==0 ){
						$wrt = 0;
					}
				}
				if( $wrt==1 ){
					$gselstk[$select_file_count] = "$key<>$dir$file<>$fild_val";
					$select_file_count++;
				}
			}
		}
	}
	closedir(dirlist);
	#--
	#tracesub("---SNAP1--");
	#for($i=0;$i<$select_file_count;$i++){
	#	tracesub("set file($i)=$gselstk[$i]");
	#}
	
	if( $sort_key ne "" ){
		if( substr($sort_typ,0,1) eq "n" ){
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@gselstk = sort {$b <=> $a} @gselstk;
			}
			else{
				@gselstk = sort {$a <=> $b} @gselstk;
			}
		}else{
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@gselstk = sort {$b cmp $a} @gselstk;
			}
			else{
				@gselstk = sort @gselstk;
			}
		}
	}
	#--
	put_xvalue($lname,"count",$select_file_count);
	for($i=0;$i<$select_file_count;$i++){
		put_xvalue($lname,$i,$gselstk[$i]);
		##tracesub("set file($i)=$gselstk[$i]");
	}
	return($select_files_max_no);
}
# ============================================================================
sub FindFileNameSkipper
# ============================================================================
{
	#--------------------------
	# t@Cԍ̌ԂT
	#--------------------------
	local($xdir    )=$_[0];
	local($filehead)=$_[1];
	local($file);
	local($xpdir,$xpfil,$xpext);
	
	@FindFileNameSkipper_stk=();
	opendir(dirlist,"$xdir");
	while($file = readdir(dirlist)){
		if( $file ne "." && $file ne ".." ){
			if( $file=~/^$filehead/ ){
				($xpdir,$xpfil,$xpext)=fnsplit($file);
				$xpfil=~s/^$filehead//g;
				push(@FindFileNameSkipper_stk,$xpfil);
			}
		}
	}
	closedir(dirlist);
	
	local($i);
	local($cnt);
	@FindFileNameSkipper_stk = sort @FindFileNameSkipper_stk;
	$cnt=@FindFileNameSkipper_stk;
	for($i=0;$i<$cnt;$i++){
		if( $i!=$FindFileNameSkipper_stk[$i] ){
			return($i);
		}
	}
	return(-1);
}
# ============================================================================
sub search_file
# ============================================================================
{
	local($dir)     =$_[0];
	local($filehead)=$_[1];
	local($bname)   =$_[2];
	local($extracts)=$_[3];
	local($file);
	local($i,$j);
	local($key);
	
	local($smbl,$frmt);
	local($xdir,$xfil,$xext);
	local($xpfilw);
	
	local($chk_cnt);
	local(@chk_dec);
	local(@chk_mrk);
	local($chk_val_0);
	local($chk_val_1);
	local($chk_decv);
	local($cmp);
	local($i);

	local($wrt);
	local($fild_val);
	# ex.$extracts
	#
	# $extracts = "ITEM_GROP".".eq.\'".$grop_name."\'";
	#
	tracesub("search_file:dir=$dir filehead=$filehead");
	
	clr_xvalue($bname);
	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if($file =~ /\.cgi$/i && $file ne ".cgi" ){
			if( $file=~/^$filehead/ ){
				$key="";
				Get_DBfile($bname,"$dir$file");
#tracesub("file=$file extracts=$extracts");
				$wrt=1;
				if( $extracts ne "" ){
					$chk_cnt=0;
					@extracts_stk=split(/,/,$extracts);
					foreach(@extracts_stk){
						# VAL0.cmp.VAL1,and.VAL2.cmp.VAL3
						if( $chk_cnt==0 ){
							($chk_val_0,$cmp,$chk_val_1,$nxp)=
								operation_split($_);
						}
						else{
							($chk_mrk[$chk_cnt],$chk_val_0,$cmp,$chk_val_1,$nxp)=
								operation_split($_);
						}
						$chk_val_0n= $chk_val_0;
						$chk_val_1n= $chk_val_1;
						$chk_val_0 = get_exvalue($bname,$chk_val_0);
						$chk_val_1 = get_exvalue($bname,$chk_val_1);
						$chk_dec[$chk_cnt]=0;
#tracesub("CHK ($chk_val_0n)$chk_val_0 $cmp ($chk_val_1n)$chk_val_1");
						if( $cmp eq "==" ){
							if( $chk_val_0 == $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "<=" ){
							if( $chk_val_0 <= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq ">=" ){
							if( $chk_val_0 >= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "<"  ){
							if( $chk_val_0 <  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq ">"  ){
							if( $chk_val_0 >  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "!=" ){
							if( $chk_val_0 != $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "eq" ){
							if( $chk_val_0 eq $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "le" ){
							if( $chk_val_0 le $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "ge" ){
							if( $chk_val_0 ge $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "lt" ){
							if( $chk_val_0 lt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "gt" ){
							if( $chk_val_0 gt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "ne" ){
							if( $chk_val_0 ne $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "head" ){
							if( $chk_val_0 =~/^$chk_val_1/ ){ $chk_dec[$chk_cnt]=1; }
						}
						$chk_cnt++;
					}
					$chk_decv=$chk_dec[0];
					for($i=1;$i<$chk_cnt;$i++){
						if( $chk_mrk[$i] eq "" || $chk_mrk[$i] eq "and" ){
							$chk_decv*=$chk_dec[$i];
						}else{
							$chk_decv+=$chk_dec[$i];
							if( $chk_decv!=0 ){
								$chk_decv=1;
							}
						}
					}
					if( $chk_decv==0 ){
						$wrt=0;
					}
				}
				if( $wrt==1 ){
					return("$dir$file");
				}
			}
		}
	}
	closedir(dirlist);
	clr_xvalue($bname);
	return("");
}
# ============================================================================
sub select_files
# ============================================================================
{
	local($dir)     =$_[0];
	local($filehead)=$_[1];
	local($bname)   =$_[2];
	local($sort_key)=$_[3];
	local($sort_typ)=$_[4];
	local($fild_add)=$_[5];
	local($null_val)=$_[6];
	local($extractD)=$_[7];
	local($file);
	local($i,$j);
	local($key);
	
	local($smbl,$frmt);
	local($xdir,$xfil,$xext);
	local($xpfilw);
	
	local($chk_cnt);
	local(@chk_dec);
	local(@chk_mrk);
	local($chk_val_0);
	local($chk_val_1);
	local($chk_decv);
	local($cmp);
	local($i);
	
	local($extracts);

	local($wrt);
	local($fild_val);
	# ex.$extracts
	#
	# $extracts = "ITEM_GROP".".eq.\'".$grop_name."\'";
	#
	tracesub("select_files:dir=$dir filehead=$filehead");
	$select_file_count=0;
	@select_file=();
	$select_files_max_no= -1;

	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if($file =~ /\.cgi$/i && $file ne ".cgi" && $file ne "." && $file ne ".."){
			if( $file=~/^$filehead/ ){
				($xpdir,$xpfil,$xpext)=fnsplit($file);
				$xpfilw=$xpfil;
				$xpfilw=~s/^$filehead//g;
				if( $xpfilw>=$select_files_max_no ){
					$select_files_max_no = $xpfilw+1;
				}
tracesub("filehead=$filehead file=$file xpfilw=$xpfilw");
#tracesub("=========================================");
				$key="";
				Get_DBfile($bname,"$dir$file");
				if( $sort_key ne "" ){
					local($decn);
					$key_lst="";
					@sort_keys = split(/,/,$sort_key);
					foreach(@sort_keys){
						($smbl,$frmt,$decn)=split(/\|/,$_);
						if( $smbl eq '%NO' ){
							$key = $xpfilw;
						}
						else{
							$key=get_xvalue($bname,$smbl);
						}
						if( $key eq ""  ){ 
							if( $null_val ne "" ){
								$key = "$null_val"; 
							}
							else{
								$key = "999999999999"; 
							}
						}else{
							if( $decn eq "d" ){
								local($kl,$kli);
								$kl=length($key);
								$mx="";
								for($kli=0;$kli<$kl;$kli++){$mx.="9";}
								$key =$mx-$key;
							}
						}
						if( $frmt ne "" ){
							$key = sprintf($frmt,$key);
						}
						$key_lst.=$key;
					}
					$key = $key_lst;
				}
				
#tracesub("file=$file extractD=$extractD");
				@select_files_field=split(/,/,$fild_add);
				$fild_val="";
				foreach(@select_files_field){
					$fild_val.=get_xvalue($bname,$_)."<>";
#tracesub("get field=$_=".get_xvalue($bname,$_));
				}
				$wrt=1;
				if( $extractD ne "" ){
					local($decd_flag) = 0;
					@extractD_stk=split(/\|\|/,$extractD);
					foreach(@extractD_stk){
						$extracts=$_;
						$chk_cnt=0;
						@extracts_stk=split(/,/,$extracts);
						foreach(@extracts_stk){
							# VAL0.cmp.VAL1,and.VAL2.cmp.VAL3
							if( $chk_cnt==0 ){
								($chk_val_0,$cmp,$chk_val_1,$nxp)=
									operation_split($_);
							}
							else{
								($chk_mrk[$chk_cnt],$chk_val_0,$cmp,$chk_val_1,$nxp)=
									operation_split($_);
							}
							$chk_val_0n= $chk_val_0;
							$chk_val_1n= $chk_val_1;
							$chk_val_0 = get_exvalue($bname,$chk_val_0);
							$chk_val_1 = get_exvalue($bname,$chk_val_1);
							$chk_dec[$chk_cnt]=0;
#tracesub("CHK ($chk_val_0n) $cmp ($chk_val_1n) = $chk_val_0 $cmp $chk_val_1");
							if( $cmp eq "==" ){
								if( $chk_val_0 == $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "<=" ){
								if( $chk_val_0 <= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq ">=" ){
								if( $chk_val_0 >= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "<"  ){
								if( $chk_val_0 <  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq ">"  ){
								if( $chk_val_0 >  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "!=" ){
								if( $chk_val_0 != $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "eq" ){
								if( $chk_val_0 eq $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "le" ){
								if( $chk_val_0 le $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "ge" ){
								if( $chk_val_0 ge $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "lt" ){
								if( $chk_val_0 lt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "gt" ){
								if( $chk_val_0 gt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "ne" ){
								if( $chk_val_0 ne $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
							}
							if( $cmp eq "head" ){
								if( $chk_val_0 =~/^$chk_val_1/ ){ $chk_dec[$chk_cnt]=1; }
							}
#tracesub("chk_dec($chk_cnt)=$chk_dec[$chk_cnt]");
							$chk_cnt++;
						}
						$chk_decv=$chk_dec[0];
						for($i=1;$i<$chk_cnt;$i++){
							if( $chk_mrk[$i] eq "" || $chk_mrk[$i] eq "and" ){
								$chk_decv*=$chk_dec[$i];
							}else{
								$chk_decv+=$chk_dec[$i];
								if( $chk_decv!=0 ){
									$chk_decv=1;
								}
							}
						}
						if( $chk_decv!=0 ){
							$decd_flag+=1;
						}
#tracesub("decd_flag=$decd_flag");
					}
					if( $decd_flag==0 ){
						$wrt = 0;
					}
				}
				if( $wrt==1 ){
					$select_file[$select_file_count] = "$key<>$dir$file<>$fild_val";
					$select_file_count++;
				}
			}
		}
	}
	closedir(dirlist);
	#--
	#tracesub("---SNAP1--");
	#for($i=0;$i<$select_file_count;$i++){
	#	tracesub("set file($i)=$select_file[$i]");
	#}
	
	if( $sort_key ne "" ){
		if( substr($sort_typ,0,1) eq "n" ){
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@select_file = sort {$b <=> $a} @select_file;
			}
			else{
				@select_file = sort {$a <=> $b} @select_file;
			}
		}else{
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@select_file = sort {$b cmp $a} @select_file;
			}
			else{
				@select_file = sort @select_file;
			}
		}
	}
	#--
	#tracesub("---SNAP2--");
	#for($i=0;$i<$select_file_count;$i++){
	#	tracesub("set file($i)=$select_file[$i]");
	#}
	return($select_files_max_no);
}
# ============================================================================
sub select_files_append
# ============================================================================
{
	local($dir)     =$_[0];
	local($filehead)=$_[1];
	local($bname)   =$_[2];
	local($sort_key)=$_[3];
	local($sort_typ)=$_[4];
	local($fild_add)=$_[5];
	local($null_val)=$_[6];
	local($extracts)=$_[7];
	local($file);
	local($i,$j);
	local($key);
	
	local($smbl,$frmt);
	local($xdir,$xfil,$xext);
	local($xpfilw);
	
	local($chk_cnt);
	local(@chk_dec);
	local(@chk_mrk);
	local($chk_val_0);
	local($chk_val_1);
	local($chk_decv);
	local($cmp);
	local($i);

	local($wrt);
	local($fild_val);
	# ex.$extracts
	#
	# $extracts = "ITEM_GROP".".eq.\'".$grop_name."\'";
	#
	tracesub("select_files:dir=$dir filehead=$filehead");
	
	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if($file =~ /\.cgi$/i && $file ne ".cgi" ){
			if( $file=~/^$filehead/ ){
				($xpdir,$xpfil,$xpext)=fnsplit($file);
				$xpfilw=$xpfil;
				$xpfilw=~s/^$filehead//g;
				if( $xpfilw>=$select_files_max_no ){
					$select_files_max_no = $xpfilw+1;
				}

				$key="";
				Get_DBfile($bname,"$dir$file");
				if( $sort_key ne "" ){
					$key_lst="";
					@sort_keys = split(/,/,$sort_key);
					foreach(@sort_keys){
						($smbl,$frmt)=split(/\|/,$_);
						if( $_ eq '%NO' ){
							$key = $xpfilw;
						}
						else{
							$key=get_xvalue($bname,$smbl);
						}
						if( $key eq ""  ){ 
							if( $null_val ne "" ){
								$key = "$null_val"; 
							}
							else{
								$key = "999999"; 
							}
						}
						if( $frmt ne "" ){
							$key = sprintf($frmt,$key);
						}
						$key_lst.=$key;
					}
					$key = $key_lst;
				}
				
#tracesub("file=$file extracts=$extracts");
				@select_files_field=split(/,/,$fild_add);
				$fild_val="";
				foreach(@select_files_field){
					$fild_val.=get_xvalue($bname,$_)."<>";
				}
				$wrt=1;
				if( $extracts ne "" ){
					$chk_cnt=0;
					@extracts_stk=split(/,/,$extracts);
					foreach(@extracts_stk){
						# VAL0.cmp.VAL1,and.VAL2.cmp.VAL3
						if( $chk_cnt==0 ){
							($chk_val_0,$cmp,$chk_val_1,$nxp)=
								operation_split($_);
						}
						else{
							($chk_mrk[$chk_cnt],$chk_val_0,$cmp,$chk_val_1,$nxp)=
								operation_split($_);
						}
						$chk_val_0n= $chk_val_0;
						$chk_val_1n= $chk_val_1;
						$chk_val_0 = get_exvalue($bname,$chk_val_0);
						$chk_val_1 = get_exvalue($bname,$chk_val_1);
						$chk_dec[$chk_cnt]=0;
tracesub("CHK ($chk_val_0n)$chk_val_0 $cmp ($chk_val_1n)$chk_val_1");
						if( $cmp eq "==" ){
							if( $chk_val_0 == $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "<=" ){
							if( $chk_val_0 <= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq ">=" ){
							if( $chk_val_0 >= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "<"  ){
							if( $chk_val_0 <  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq ">"  ){
							if( $chk_val_0 >  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "!=" ){
							if( $chk_val_0 != $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "eq" ){
							if( $chk_val_0 eq $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "le" ){
							if( $chk_val_0 le $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "ge" ){
							if( $chk_val_0 ge $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "lt" ){
							if( $chk_val_0 lt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "gt" ){
							if( $chk_val_0 gt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "ne" ){
							if( $chk_val_0 ne $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "head" ){
							if( $chk_val_0 =~/^$chk_val_1/ ){ $chk_dec[$chk_cnt]=1; }
						}
						$chk_cnt++;
					}
					$chk_decv=$chk_dec[0];
					for($i=1;$i<$chk_cnt;$i++){
						if( $chk_mrk[$i] eq "" || $chk_mrk[$i] eq "and" ){
							$chk_decv*=$chk_dec[$i];
						}else{
							$chk_decv+=$chk_dec[$i];
							if( $chk_decv!=0 ){
								$chk_decv=1;
							}
						}
					}
					if( $chk_decv==0 ){
						$wrt=0;
					}
				}
				if( $wrt==1 ){
					$select_file[$select_file_count] = "$key<>$dir$file<>$fild_val";
					$select_file_count++;
				}
			}
		}
	}
	closedir(dirlist);
	#--
	#tracesub("---SNAP1--");
	#for($i=0;$i<$select_file_count;$i++){
	#	tracesub("set file($i)=$select_file[$i]");
	#}
	
	return($select_files_max_no);
}
# ============================================================================
# gfiles
# ============================================================================
# ============================================================================
sub search_gfiles
# ============================================================================
{
	local($fld_at)=$_[0];
	local($dat_at)=$_[1];
	local($key_fl)=$_[2];
	local($i,$j);
	local($cnt);
	local($fld_cnt);
	local($sb,$vl);
	
	local($top_rec)=-1;
	local($count)  =0;
	local($f);
	
	@search_gfiles_no  = ();
	@search_gfiles_dt  = ();
	@search_gfiles_lst = ();
	@search_gfiles_lst = split(/<>/,$key_fl);
	foreach(@search_gfiles_lst){
		($sb,$vl)=split(/==/,$_);
		push(@search_gfiles_no,get_xvalue($fld_at."_no",$sb));
		push(@search_gfiles_dt,$vl);
	}
	
	$cnt = get_xvalue($dat_at,"LISTCOUNT");
	for($i=0;$i<$cnt;$i++){
		@search_gfiles_lst = split(/<>/,get_xvalue($dat_at,"LIST".$i));
		$fld_cnt=0;
		@search_gfiles_vl = ();
		foreach(@search_gfiles_lst){
			if( $fld_cnt>=2 ){
				push(@search_gfiles_vl,$_);
			}
			$fld_cnt++;
		}
		$f=0;
		for($j=0;$j<@search_gfiles_no;$j++){
			if( $search_gfiles_dt[$j] eq $search_gfiles_vl[$search_gfiles_no[$j]] ){
				$f = 1;
			}
		}
		if( $top_rec==-1 ){
			if( $f==1 ){
				$top_rec=$i;
				$count  =1;
			}
		}
		else{
			if( $f==1 ){
				$count++;
			}
			else{
				return($top_rec,$count);
			}
		}
	}
	return($top_rec,$count);
}
# ============================================================================
sub select_gfiles
# ============================================================================
{

	local($dir)     =$_[0];
	local($filehead)=$_[1];
	local($bname)   =$_[2];
	local($sort_key)=$_[3];
	local($sort_typ)=$_[4];
	local($fild_add)=$_[5];
	local($null_val)=$_[6];
	local($file);
	local($i,$j);
	local($key);
	local($smbl,$frmt);
	
	local($xdir,$xfil,$xext);
	local($xpfilw);
	local($fild_val);
	
	#tracesub("select_gfiles:dir=$dir filehead=$filehead");
	$select_gfile_count=0;
	@select_gfile=();

	$select_gfiles_max_no= -1;

	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if($file =~ /\.cgi$/i && $file ne ".cgi" ){
			if( $file=~/^$filehead/ ){
				($xpdir,$xpfil,$xpext)=fnsplit($file);
				$xpfilw=$xpfil;
				$xpfilw=~s/^$filehead//g;
				if( $xpfilw>=$select_gfiles_max_no ){
					$select_gfiles_max_no = $xpfilw+1;
				}

				$key="";
				Get_DBfile($bname,"$dir$file");
				if( $sort_key ne "" ){
					$key_lst="";
					@sort_keys = split(/,/,$sort_key);
					foreach(@sort_keys){
						($smbl,$frmt)=split(/\|/,$_);
						if( $_ eq '%NO' ){
							$key = $xpfilw;
						}
						else{
							$key=get_xvalue($bname,$smbl);
						}
						if( $key eq ""  ){ 
							if( $null_val ne "" ){
								$key = $null_val; 
							}else{
								$key = "999999"; 
							}
						}
						if( $frmt ne "" ){
							$key = sprintf($frmt,$key);
						}
						$key_lst.=$key;
					}
					$key = $key_lst;
				}
				@select_gfiles_field=split(/,/,$fild_add);
				$fild_val="";
				foreach(@select_gfiles_field){
					$fild_val.=get_xvalue($bname,$_)."<>";
				}
				$select_gfile[$select_gfile_count] = "$key<>$dir$file<>$fild_val";
				$select_gfile_count++;
			}
		}
	}
	closedir(dirlist);
	#--
#	for($i=0;$i<$select_gfile_count;$i++){
#		tracesub("set file($i)=$select_gfile[$i]");
#	}
	
	if( $sort_key ne "" ){
		if( substr($sort_typ,0,1) eq "n" ){
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@select_gfile = sort {$b <=> $a} @select_gfile;
			}
			else{
				@select_gfile = sort {$a <=> $b} @select_gfile;
			}
		}else{
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@select_gfile = sort {$b cmp $a} @select_gfile;
			}
			else{
				@select_gfile = sort @select_gfile;
			}
		}
	}
#tracesub("---SNAP1--");
#	for($i=0;$i<$select_gfile_count;$i++){
#tracesub("set file($i)=$select_gfile[$i]");
#	}

#tracesub("bname=$bname");
	clr_xvalue($bname);
	put_xvalue($bname,"LISTCOUNT",$select_gfile_count);
	for($i=0;$i<$select_gfile_count;$i++){
		put_xvalue($bname,"LIST".$i,$select_gfile[$i]);
#tracesub("set file($i)=$select_gfile[$i]");

#($xxxkey,$xxxfile)=split(/<>/,$select_gfile[$i]);
#tracesub("set($i) key=$xxxkey file=$xxxfile");

	}

	return($select_gfile_count,$select_gfiles_max_no);

}
# ============================================================================
sub get_gfiles
# ============================================================================
{
	local($file_athd)    =$_[0];
	local($file_head)    =$_[1];
	local($fld_at)       =$_[2];
	local($dat_at)       =$_[3];
	local($sortfield)    =$_[4];
	local($sorttype)     =$_[5];
	local($datafieldpath)=$_[6];
	local($datapath)     =$_[7];
	local($null_val)     =$_[8];
	
	local($filedeff);
	local($fileno);
	local($flddef_count);
	local($pickup_field)="";
	local($i);
	local($field_defname);
	local($field_name);
	local($cnt,$max);
	
	clr_xvalue($fld_at);
	clr_xvalue($fld_at."_no");
	clr_xvalue($dat_at);

	$filedeff = $datafieldpath."zp_".$file_athd."_flddef.cgi";
	($fileno)=get_file_attr($fld_at,$filedeff);
	$flddef_count = get_xvalue($fld_at,"block_fieldlist_line");

#tracesub("get_gfiles:datafieldpath=$datafieldpath filedeff=$filedeff");
	$pickup_field="";
	for($i=0;$i<$flddef_count;$i++){
		$field_defname = "block_fieldlist_".$i;
		$field_name    = get_xvalue($fld_at,$field_defname."_fieldname");
		if( $pickup_field ne "" ){ $pickup_field.=","; }
#tracesub("get_gfiles:field_name=$field_name");
		
		$pickup_field.=$field_name;
		put_xvalue($fld_at."_no",$field_name,$i);
	}
	($cnt,$max) = select_gfiles($datapath,$file_head."_",$dat_at,
						$sortfield,$sorttype,$pickup_field,$null_val);
	return($flddef_count,$cnt,$max);
}
# ============================================================================
sub get_sub_files
# ============================================================================
{
	local($dir)     =$_[0];
	local($filehead)=$_[1];
	local($bname)   =$_[2];
	local($sort_key)=$_[3];
	local($sort_typ)=$_[4];
	local($fild_add)=$_[5];
	local($null_val)=$_[6];
	local($file);
	local($i,$j);
	local($key);
	
	local($xdir,$xfil,$xext);
	local($xpfilw);
	local($fild_val);
	
	tracesub("get_sub_files:dir=$dir");
	$sub_files_count=0;
	@sub_files=();

	$sub_filess_max_no= -1;

	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if($file =~ /\.cgi$/i && $file ne ".cgi" ){
			if( $file=~/^$filehead/ ){
				($xpdir,$xpfil,$xpext)=fnsplit($file);
				$xpfilw=$xpfil;
				$xpfilw=~s/^$filehead//g;
				if( $xpfilw>=$sub_filess_max_no ){
					$sub_filess_max_no = $xpfilw+1;
				}
				
				$key="";
				Get_DBfile($bname,"$dir$file");
				if( $sort_key ne "" ){
					$key_lst="";
					@sort_keys = split(/,/,$sort_key);
					foreach(@sort_keys){
						($smbl,$frmt)=split(/\|/,$_);
						if( $_ eq '%NO' ){
							$key = $xpfilw;
						}
						else{
							$key=get_xvalue($bname,$smbl);
						}
						if( $key eq ""  ){
							if( $null_val ne "" ){
								$key = $null_val; 
							}else{
								$key = "999999"; 
							}
						}
						if( $frmt ne "" ){
							$key = sprintf($frmt,$key);
						}
						$key_lst.=$key;
					}
					$key = $key_lst;
				}
				@sub_filess_field=split(/,/,$fild_add);
				$fild_val="";
				foreach(@sub_filess_field){
					$fild_val.=get_xvalue($bname,$_)."<>";
				}
				$sub_files[$sub_files_count] = "$key<>$dir$file<>$fild_val<>";
				$sub_files_count++;
			}
		}
	}
	closedir(dirlist);
	#--
	if( $sort_key ne "" ){
		if( substr($sort_typ,0,1) eq "n" ){
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@sub_files = sort {$b <=> $a} @sub_files;
			}
			else{
				@sub_files = sort {$a <=> $b} @sub_files;
			}
		}else{
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@sub_files = sort {$b cmp $a} @sub_files;
			}
			else{
				@sub_files = sort @sub_files;
			}
		}
	}
	clr_xvalue($bname);
	for($i=0;$i<$sub_files_count;$i++){
		put_xvalue($bname,"sub_file$i",$sub_files[$i]);
	}
	return($sub_files_count,$sub_filess_max_no);
}
# ============================================================================
sub get_filelist
# ============================================================================
{
	local($dir)          =$_[0];
	local($filehead)     =$_[1];
	local($bname)        =$_[2];
	local($fild_add)     =$_[3];
	local($line_key)     =$_[4];

	local($file);
	local($i);
	local($xdir,$xfil,$xext);
	local($xpfilw);
	local($fild_val);
	
	tracesub("get_filelist:dir=$dir filehead=$filehead bname=$bname line_key=$line_key");
	#--- init ---
	for($i=0;$i<$filelist_count{$bname};$i++){
		$filelist{$bname."_".$i} = "";
	}
	#--- read ---
	clr_xvalue($bname."_KEY");
	$filelist_count{$bname} =0;
	$filelist_max_no{$bname}=-1;
	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if( $file ne "." && $file ne ".." ){
			if( $file=~/^$filehead/ ){
				($xpdir,$xpfil,$xpext)=fnsplit($file);
				$xpfilw=$xpfil;
				$xpfilw=~s/^$filehead//g;
				$xpfilw=~s/^_//g;
#tracesub("file=$file xpfil=$xpfil filehead=$filehead xpfilw=$xpfilw");
				if( $xpfilw>=$filelist_max_no{$bname} ){
					$filelist_max_no{$bname} = $xpfilw+1;
				}
				$fild_val="";
				$set_keys="";
				if( $fild_add ne "" || $line_key ne "" ){
					Get_DBfile($bname,"$dir$file");
					if( $fild_add ne "" ){
						@sub_filess_field=split(/,/,$fild_add);
						foreach(@sub_filess_field){
							$fild_val.=get_xvalue($bname,$_)."<>";
						}
					}
					if( $line_key ne "" ){
						@sub_filess_field=split(/,/,$line_key);
						foreach(@sub_filess_field){
							$set_keys.=get_xvalue($bname,$_)."<>";
						}
						put_xvalue($bname."_KEY",$set_keys,$filelist_count{$bname});
						$xval=get_xvalue($bname."_KEY",$set_keys);
#tracesub("KEYSET $bname"."_KEY ".get_xvalue($bname,$_)."=".$filelist_count{$bname}." rev=$xval set_keys=$set_keys" );
					}
				}
				$filelist{$bname."_".$filelist_count{$bname}} = 
					"$xpfilw<>$dir$file<>$fild_val<>";
#tracesub("get_filelist=($bname)(".$filelist_count{$bname}.")=$xpfilw<>$dir$file<>" );
				$filelist_count{$bname}++;
			}
		}
	}
	closedir(dirlist);
	local($snap_debug)=0;
	if( $snap_debug==1 ){
		$wrk=snap_xvalue($bname."_KEY");
		$wrk=~s/<cr>/\n/g;
		tracesub("===SNAP===".$bname."_KEY");
		tracesub($wrk);
		tracesub("==========");
	}
	return($filelist_count{$bname},$filelist_max_no{$bname});
}
# ============================================================================
# ============================================================================
# ============================================================================
sub filetable_dec
# ============================================================================
{
	local($dat_at)=$_[0];
	local($line)  =$_[1];
	local($skip)  =$_[2];
	local($no)    =0;
	local($count) =0;
	local($flip)  =1;
	local($key)   ="";
	local($file)  ="";
	local($smbl)  ="";
	
	clr_xvalue($dat_at);
	@filetable_dec_stk=split(/<>/,$line);
	foreach(@filetable_dec_stk){
		if( $no>=$skip ){
			if( $flip==1 ){
				$smbl = $_;
				if( $count<2 ){
					$key=$_;
				}
			}else{
				if( $count<2 ){
					$file=$_;
				}else{
					put_xvalue($dat_at,$smbl,$_);
				}
			}
			$flip=3-$flip;
			$count++;
		}
		$no++;
	}
	return($key,$file);
}
# ============================================================================
sub FilecopyMeta
# ============================================================================
{
	local($frpath)=$_[0];
	local($topath)=$_[1];
	local($cpfile)=$_[2];
	local($cmd);
	
	$cmd = "cp $frpath$cpfile $topath$cpfile";
	system($cmd);
}
# ============================================================================
sub filetable_get
# ============================================================================
{
	local($lst_at)  =$_[0];
	local($dir)     =$_[1];
	local($filehead)=$_[2];
	local($sort_key)=$_[3];
	local($sort_typ)=$_[4];
	local($fild_add)=$_[5];
	local($null_val)=$_[6];
	local($extracts)=$_[7];
	local($file);
	local($i,$j);
	local($key);
	local($bname)="filetablework";
	
	local($smbl,$frmt);
	local($xdir,$xfil,$xext);
	local($xpfilw);
	
	local($chk_cnt);
	local(@chk_dec);
	local(@chk_mrk);
	local($chk_val_0);
	local($chk_val_1);
	local($chk_decv);
	local($cmp);
	local($i);

	local($wrt);

	local($select_files_max_no)= -1;
	local($count);
	local($fild_val);

	# ex.$extracts
	#
	# $extracts = "ITEM_GROP".".eq.\'".$grop_name."\'";
	#
	tracesub("filetable_get:dir=$dir filehead=$filehead");
	clr_xvalue($lst_at);
	@filelist_stk=();
	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if($file =~ /\.cgi$/i && $file ne ".cgi" ){
			if( $file=~/^$filehead/ ){
				($xpdir,$xpfil,$xpext)=fnsplit($file);
				$xpfilw=$xpfil;
				$xpfilw=~s/^$filehead//g;
				if( $xpfilw>=$select_files_max_no ){
					$select_files_max_no = $xpfilw+1;
				}
				$key="";
				Get_DBfile($bname,"$dir$file");
				if( $sort_key ne "" ){
					$key_lst="";
					@sort_keys = split(/,/,$sort_key);
					foreach(@sort_keys){
						($smbl,$frmt)=split(/\|/,$_);
						if( $_ eq '%NO' ){
							$key = $xpfilw;
						}
						else{
							$key=get_xvalue($bname,$smbl);
						}
						if( $key eq ""  ){ 
							if( $null_val ne "" ){
								$key = "$null_val"; 
							}
							else{
								$key = "999999"; 
							}
						}
						if( $frmt ne "" ){
							$key = sprintf($frmt,$key);
						}
						$key_lst.=$key;
					}
					$key = $key_lst;
				}
				@select_files_field=split(/,/,$fild_add);
				$fild_val="";
				foreach(@select_files_field){
					$fild_val.=$_."<>".get_xvalue($bname,$_)."<>";
				}
				$wrt=1;
				if( $extracts ne "" ){
					$chk_cnt=0;
					@extracts_stk=split(/,/,$extracts);
					foreach(@extracts_stk){
						# VAL0.cmp.VAL1,and.VAL2.cmp.VAL3
						if( $chk_cnt==0 ){
							($chk_val_0,$cmp,$chk_val_1,$nxp)=
								operation_split($_);
						}
						else{
							($chk_mrk[$chk_cnt],$chk_val_0,$cmp,$chk_val_1,$nxp)=
								operation_split($_);
						}
						$chk_val_0 = get_exvalue($bname,$chk_val_0);
						$chk_val_1 = get_exvalue($bname,$chk_val_1);
						$chk_dec[$chk_cnt]=0;
						if( $cmp eq "==" ){
							if( $chk_val_0 == $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "<=" ){
							if( $chk_val_0 <= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq ">=" ){
							if( $chk_val_0 >= $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "<"  ){
							if( $chk_val_0 <  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq ">"  ){
							if( $chk_val_0 >  $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "!=" ){
							if( $chk_val_0 != $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "eq" ){
							if( $chk_val_0 eq $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "le" ){
							if( $chk_val_0 le $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "ge" ){
							if( $chk_val_0 ge $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "lt" ){
							if( $chk_val_0 lt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "gt" ){
							if( $chk_val_0 gt $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "ne" ){
							if( $chk_val_0 ne $chk_val_1 ){ $chk_dec[$chk_cnt]=1; }
						}
						if( $cmp eq "head" ){
							if( $chk_val_0 =~/^$chk_val_1/ ){ $chk_dec[$chk_cnt]=1; }
						}
						$chk_cnt++;
					}
					$chk_decv=$chk_dec[0];
					for($i=1;$i<$chk_cnt;$i++){
						if( $chk_mrk[$i] eq "" || $chk_mrk[$i] eq "and" ){
							$chk_decv*=$chk_dec[$i];
						}else{
							$chk_decv+=$chk_dec[$i];
							if( $chk_decv!=0 ){
								$chk_decv=1;
							}
						}
					}
					if( $chk_decv==0 ){
						$wrt=0;
					}
				}
				if( $wrt==1 ){
					push(@filelist_stk,"$key<>$dir$file<>$fild_val");
				}
			}
		}
	}
	closedir(dirlist);
	#--
	#tracesub("---SNAP1--");
	#for($i=0;$i<$select_file_count;$i++){
	#	tracesub("set file($i)=$select_file[$i]");
	#}
	
	if( $sort_key ne "" ){
		if( substr($sort_typ,0,1) eq "n" ){
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@filelist_stk = sort {$b <=> $a} @filelist_stk;
			}
			else{
				@filelist_stk = sort {$a <=> $b} @filelist_stk;
			}
		}else{
			if( $fldv{'sort'} eq "ds" || index($sort_typ,"(ds)")!=-1 ){
				@filelist_stk = sort {$b cmp $a} @filelist_stk;
			}
			else{
				@filelist_stk = sort @filelist_stk;
			}
		}
	}
	#--
	$count=@filelist_stk;
	put_xvalue($lst_at,$lst_at."_ROWS",$count);
	put_xvalue($lst_at,$lst_at."_MAXS",$select_files_max_no);
	for($i=0;$i<$count;$i++){
		put_xvalue($lst_at,$lst_at."_".$i,$filelist_stk[$i]);
	}
#	tracesub("---filetable_get SNAP2--");
#	$count=@filelist_stk;
#	for($i=0;$i<$count;$i++){
#		tracesub($lst_at."_".$i."=".$filelist_stk[$i]);
#	}
#	tracesub("------------------------");
	
	return($select_files_max_no);
}
# ============================================================================
sub operation_split
# ============================================================================
{
	local($buf)=$_[0];
	local($p);
	local($i,$l);
	local($sw)=0;
	local($remainder)="";
	local($ch);
	@operation_split_stk=();
	
	$l=length($buf);
	
	for($i=0;$i<$l;$i++){
		$ch = substr($buf,$i,1);
		if( iskanji($ch)!=0 ){
			$remainder.=$ch;
			$i++;
			$ch = substr($buf,$i,1);
			$remainder.=$ch;
			
		}else{
			if( $sw==0 ){
				if(     $ch eq "\'" ){
					$sw=1;
					
				}elsif( $ch eq "." ){
					push(@operation_split_stk,$remainder);
					$remainder="";
					$ch="";
				}
			}else{
				if( $ch eq "\'" ){
					$sw=0;
				}
			}
			$remainder.=$ch;
		}
	}
	push(@operation_split_stk,$remainder);
$remainder ="$buf=";
$remainder.="($operation_split_stk[0])";
$remainder.="($operation_split_stk[1])";
$remainder.="($operation_split_stk[2])";
$remainder.="($operation_split_stk[3])";

#tracesub("operation_split:$remainder");

	return(	$operation_split_stk[0],
			$operation_split_stk[1],
			$operation_split_stk[2],
			$operation_split_stk[3]);
}
# ============================================================================
sub filetime
# ============================================================================
{
	local($file)=$_[0];
	local($cmd) =$_[1];
	local($ftime);
	local($org_sec,$org_min,$org_hor,$org_mday,$org_mmon,$org_year);
	local($rettime)="";
	
	$ftime=(stat $file)[9];
	($org_sec,$org_min,$org_hor,$org_mday,$org_mmon,$org_year)=localtime($ftime);
	$org_year+=1900;
	$org_mmon++;
	if(     $cmd=~/DATE/i ){
		return( sprintf("%04d/%02d/%02d",$org_year,$org_mmon,$org_mday) );
	}elsif( $cmd ne "" ){
		if( $cmd=~/YEAR/i ){
			$rettime.=sprintf("%04d",$org_year);
		}
		if( $cmd=~/MONTH/i ){
			if( $rettime ne "" ){ $rettime.="/"; }
			$rettime.=sprintf("%02d",$org_mmon);
		}
		if( $cmd=~/DAY/i ){
			if( $rettime ne "" ){ $rettime.="/"; }
			$rettime.=sprintf("%02d",$org_mday);
		}
		if( $cmd=~/HOUR/i ){
			if( $rettime ne "" ){ $rettime.=" "; }
			$rettime.=sprintf("%02d",$org_hor);
		}
		if( $cmd=~/MINI/i ){
			if( $rettime ne "" ){ $rettime.=":"; }
			$rettime.=sprintf("%02d",$org_min);
		}
		return($rettime);
	}
	return( sprintf("%04d/%02d/%02d %02d:%02d",
				$org_year,$org_mmon,$org_mday,$org_hor,$org_min) );
}
# ============================================================================
sub filetime_check_copySingle
# ============================================================================
{
	local($frpath)=$_[0];
	local($file  )=$_[1];
	local($topath)=$_[2];
	local($toall )=$_[3];	# all ɂƖɃRs[
	local($uncopy)=$_[4];	# Rs[Ȃt@CXgɂđƎw肳ꂽt@C̓Rs[Ȃ
	local($org_file);
	local($trg_file);
	local($org_ftime);
	local($trg_ftime);
	
	tracesub("filetime_check_copySingle frpath=$frpath file=$file topath=$topath toall=$toall uncopy=$uncopy");
	
	if( $uncopy ne "" ){
		if( index($uncopy,$file)!=-1 ){
			return;
		}
	}
	$org_file = $frpath.$file;
	$trg_file = $topath.$file;
	$org_ftime=filetime($org_file);
	if( $toall ne "all" ){
		if( $toall eq "undefonly" ){
			if( -f $trg_file ){
				return;
			}
		}
		if( -f $trg_file ){
			$trg_ftime=filetime($trg_file);
			if( $org_ftime lt $trg_ftime ){
				return;
			}
		}
	}
	$cmd = "cp $org_file $trg_file";
	system($cmd);

}
# ============================================================================
sub filetime_check_copy
# ============================================================================
{
	local($frpath)=$_[0];
	local($flhead)=$_[1];
	local($topath)=$_[2];
	local($toall) =$_[3];	# all ɂƖɃRs[
	local($uncopy)=$_[4];	# Rs[Ȃt@CXgɂđƎw肳ꂽt@C̓Rs[Ȃ
	local($file);
	local($cmd);
	local($org_file);
	local($trg_file);
	local($copy_flag);
	local($xdir,$xfil,$xext);
	
tracesub("filetime_check_copy:(toall=$toall uncopy=$uncopy)frpath=$frpath topath=$topath flhead=$flhead");
	opendir(dirlist,"$frpath");
	while($file = readdir(dirlist)){
		if( $file ne "." && $file ne ".." ){
			$copy_flag=1;
#tracesub("filetime_check_copy:$file");
			if( $flhead ne "" ){
				if( $file=~/^$flhead/ ){
				}else{
					$copy_flag=0;
				}
			}
			if( $copy_flag==1 ){
				$org_file = $frpath.$file;
				$trg_file = $topath.$file;
#tracesub(" filetime_check_copy:org_file=$org_file trg_file=$trg_file");
				$copy_flag=1;
				if( $toall ne "all" ){
					if( $toall eq "undefonly" ){
						if( -f $trg_file ){
							$copy_flag=0;
						}
					}else{
						if( -f $trg_file ){
							$org_ftime=filetime($org_file);
							$trg_ftime=filetime($trg_file);
							if( $org_ftime lt $trg_ftime ){
								$copy_flag=0;
							}
						}
					}
				}
				if( $uncopy ne "" ){
#tracesub(" filetime_check_copy:trg_file=$trg_file uncopy=$uncopy");
					if( index($uncopy,$file)!=-1 ){
						$copy_flag = 0;
					}
				}
				if( $copy_flag==1 ){
					
					($xdir,$xfil,$xext   )=fileIO_fnsplit($org_file);
					$copy_flag=0;
					if( $xext=~/\.css/i && -f $trg_file ){
						fileIO_CSSMARGE($org_file,$trg_file);
						
					}else{
						$cmd = "cp $org_file $trg_file";
						system($cmd);
					}

#tracesub("   filetime_check_copy:cmd=$cmd");

					if( $xext eq ".cgi" ){
						$cmd = "chmod 755 $trg_file";
						system($cmd);
					}
				}else{
#tracesub("   ] CANCEL2 filetime_check_copy:$file");
				}
			}else{
#tracesub("   ] CANCEL filetime_check_copy:$file");
			}
		}
	}
	closedir(dirlist);
}
# ================================================================================
sub fileIO_fnsplit
# ================================================================================
{
	# t@C𕪊
	# USEGE
	#local($fileparaset,$vdir,$vfil,$vext);
	# $fileparaset = fnsplit($filename,'\..*');
	# ($vdir,$vfil,$vext)=split(/<>/,$fileparaset);
	
	local($file)=$_[0];
	local($l,$i);
	local($dirp,$fils,$filp,$w);
	local($dir,$fil,$ext);

	$l = length($file);
	$dirp=-1;
	for($i=0;$i<$l;$i++){
		$w = substr($file,$i,1);
		if( $w eq "/" ){
			$dirp=$i;
		}
	}
#tracesub("dirp=$dirp");
	if( $dirp==-1 ){
		$dir = "";
		$fils= 0;
	}else{
		$dir = substr($file,0,$dirp+1);
		$fils= $dirp+1;
	}
#tracesub("fils=$fils");
	$filp=-1;
	for($i=$fils;$i<$l;$i++){
		$w = substr($file,$i,1);
		if( $w eq "." ){
			$filp=$i;
		}
	}
#tracesub("filp=$filp");
	if( $filp==-1 ){
		$fil = substr($file,$fils);
		$ext = "";
	}else{
		$fil = substr($file,$fils,$filp-$fils);
		$ext = substr($file,$filp);
	}
	return($dir,$fil,$ext);
}
# ============================================================================
sub template_convert_copy
# ============================================================================
{
	local($org_templateDIR)=$_[0];
	local($filename)       =$_[1];
	local($dst_templateDIR)=$_[2];
	local($toall)          =$_[3];
	
	local($frfile);
	local($tofile);
	local($indata);
	
	local($buf);
	local($spbuf);
	
	local($org_ftime);
	local($trg_ftime);
	
#	tracesub("template_convert_copy:$filename $org_templateDIR to $dst_templateDIR");
	
	$frfile = $org_templateDIR.$filename;
	$tofile = $dst_templateDIR.$filename;
	
	
	if( $toall ne "all" ){
		if( -f $tofile ){
			$org_ftime=filetime($frfile);
			$trg_ftime=filetime($tofile);
			if( $org_ftime lt $trg_ftime ){
				return(0);
			}
		}
	}
	
	open(TEMPL_IN,$frfile);
	open(OUTFP   ,">$tofile");
	while( ($buf=<TEMPL_IN>) ){
		$buf=~s/\n//g;
		$buf=~s/\xd//g;
		$spbuf=$buf;
		$spbuf=~s/\s+//g;
		$spbuf=~s/\t+//g;
		if( substr($spbuf,0,7) eq '<!--%F:' ){
			$indata="$buf\n";
			while( ($buf=<TEMPL_IN>) ){
				$buf=~s/\n//g;
				$buf=~s/\xd//g;
				$spbuf=$buf;
				$spbuf=~s/\s+//g;
				$spbuf=~s/\t+//g;
				if( substr($spbuf,0,8) eq '<!--/%F:' ){
tracesub("fmacro indata=$indata");
					$buf=fMacroEX($indata."$buf\n");
					###$buf = "<!--fmacro-->\n".$buf."\n<!--/fmacro-->";
					last;
				}
				$indata.="$buf\n";
			}
		}
		print OUTFP "$buf\n";
	}
	close(OUTFP);
	close(TEMPL_IN);
	return(1);
}
# ============================================================================
sub nest_mkdir
# ============================================================================
{
	local($dir)=$_[0];
	local($mkdir_name)="";
	local($xdir,$xfil,$xext);

	($xdir,$xfil,$xext)=fnsplit($dir);
	@nest_mkdir_stk = split(/\//,$xdir);
	foreach(@nest_mkdir_stk){
		$mkdir_name .= $_ . "/";
		tracesub("--- nest_mkdir  mkdir=$mkdir_name ---");
		mkdir($mkdir_name);
	}
}
# ============================================================================
sub kill_dir
# ============================================================================
{
	local($dir) =$_[0];
	local($head)="";
	local($ext) ="";
	local($cmd);
	
	kill_files($dir,$head,$ext);
	
	$cmd = "rmdir $dir";
	system($cmd);
}
# ============================================================================
sub kill_files
# ============================================================================
{
	local($dir) =$_[0];
	local($head)=$_[1];
	local($ext) =$_[2];
	local($file);
	local($xdir,$xfil,$xext);
	local($del_flag);
	
	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if( $file ne "." && $file ne ".." ){
			$del_flag=1;
			if( $head ne "" ){
				if( $file=~/^$head/ ){
				}else{
					$del_flag=0;
				}
			}
			if( $ext ne "" ){
				($xdir,$xfil,$xext)=fnsplit($file);
				if( $xext ne $ext ){
					$del_flag=0;
				}
			}
#tracesub("killfiles:$dir $file del_flag=$del_flag");
			if( $del_flag==1 ){
				unlink($dir.$file);
			}
		}
	}
	closedir(dirlist);
}
# ============================================================================
sub make_tempfile
# ============================================================================
{
	local($path)=$_[0];
	local($head)=$_[1];
	local($ext) =$_[2];
	local($file);
	local($no)=0;
	
	if($ext eq ""){ $ext=".html"; }

	if( $path eq "" ){ $path="./"; }
	make_temp_kill($path,$head,$ext);
	
	$file = $head.sprintf("_TEMPS_%04d%02d%02d%02d%02d",$year,$mon,$mday,$hour,$min)."_temp".$no.$ext;
	while( -f $file ){
		$no++;
		$file = $head.sprintf("_TEMPS_%04d%02d%02d%02d%02d",$year,$mon,$mday,$hour,$min)."_temp".$no.$ext;
	}
	return($file);
}
# ============================================================================
sub make_temp_kill
# ============================================================================
{
	local($dir) =$_[0];
	local($head)=$_[1];
	local($ext) =$_[2];
	
	local($p);
	local($yr,$mn,$dy,$hr,$mi);
	
	local($file);
	local($xdir,$xfil,$xext);
	local($del_flag);
	local($sec,$min,$hour,$mday,$mon,$year,$weekday);
	
	local($xtime1);
	
	use Time::Local;
	
	($sec,$min,$hour,$mday,$mon,$year,$weekday) = gmtime(time + 9*60*60+$time_move);
	$mon++;
	$year=$year+1900;
	$date    = sprintf("%04d/%02d/%02d,%02d:%02d",$year,$mon,$mday,$hour,$min);
	
	opendir(dirlist,"$dir");
	while($file = readdir(dirlist)){
		if( $file ne "." && $file ne ".." ){
			$del_flag=1;
			if( $head ne "" ){
				if( $file=~/^$head/ ){
				}else{
					$del_flag=0;
				}
			}
			if( $ext ne "" ){
				($xdir,$xfil,$xext)=fnsplit($file);
				if( $xext ne $ext ){
					$del_flag=0;
				}
			}
			if( $del_flag==1 ){
				$p=index($file,"_TEMPS_");
				if( $p!=-1 ){
					$p+=7;
					$yr = substr($file,$p   ,4);
					$mn = substr($file,$p+4 ,2);
					$dy = substr($file,$p+6 ,2);
					$hr = substr($file,$p+8 ,2);
					$mi = substr($file,$p+10,2);
					
$xtime1= timelocal(0,$mi,$hr,$dy,$mn-1,$yr);
($xsec,$xmin,$xhour,$xday,$xmon,$xyear)=localtime($xtime1+60*3);	#3min
$xyear=$xyear+1900;
tracesub("TIME ORG=".sprintf("%04d/%02d/%02d,%02d:%02d",$yr,$mn,$dy,$hr,$mi));
tracesub("TIME NXT=".sprintf("%04d/%02d/%02d,%02d:%02d",$xyear,$xmon,$xday,$xhour,$xmin,$xsec));

					#$hr++;
					#if( $hr>23 ){
					#	$hr = 0;
					#	$dy++;
					#	if( $dy>31 ){
					#		$dy = 1;
					#		$mn++;
					#		if( $mn>12 ){
					#			$mn=1;
					#			$yr++;
					#		}
					#	}
					#}
					#$chk_date = sprintf("%04d/%02d/%02d,%02d:%02d",$yr,$mn,$dy,$hr,$mi);
					$chk_date = sprintf("%04d/%02d/%02d,%02d:%02d",$xyear,$xmon,$xday,$xhour,$xmin,$xsec);
tracesub("now:$date > file:$chk_date");

					if($date gt $chk_date){
						tracesub("kill:$file");
						unlink($dir.$file);
					}
				}
			}
		}
	}
	closedir(dirlist);
}
# ============================================================================
sub mkdir_Tree
# ============================================================================
{
	local($dir) =$_[0];
	local($head)=$_[1];
	local($foot)=$_[2];
	local($stkT)=$_[3];
	local($lvl)=0;
	##-------------------------------------------------------------------------
	## --- ʃX^bNŗ~Ƃ --- PiȂ炱OK
	#	mkdir_Tree($TCS_PATH,"tcsMEMB_",".cgi","");
	#	local($i,$e);
	#	local($lvl,$dir,$file);
	#	$e = @mkdir_Tree_file;
	#	for($i=0;$i<$e;$i++){
	#		($lvl,$dir,$file) = split(/<>/,$mkdir_Tree_file[$i]);
	#		tracesub("dirTree($i):$mkdir_Tree_file[$i]");
	#	}
	## --- xvalue ŗ~Ƃ --- ɕȂ炱
	#	clr_xvalue($bname);
	#	mkdir_Tree($TCS_PATH,"tcsMEMB_",".cgi",$bname);
	#	$e = get_xcnt($bname);
	#	for($i=0;$i<$e;$i++){
	#		$n = get_xsimbol($bname,$i);
	#		tracesub("dirTree($i):dir=$n files=".get_xvalue($bname,$n));
	#	}
	## --- dir_tree ̂ݗ~Ƃ 
	#	$e = @mkdir_Tree_dirc;
	#	for($i=0;$i<$e;$i++){
	#		($lvl,$dir,$file) = split(/<>/,$mkdir_Tree_dirc[$i]);
	#		tracesub("dirTree($i):$mkdir_Tree_dirc[$i]");
	#	}
	##-------------------------------------------------------------------------
	@mkdir_Tree_dirc=();
	@mkdir_Tree_file=();
	clr_xvalue("dirtree");
	
	mkdir_Tree_getdir($dir,$head,$foot,$stkT,$lvl);
	
	tracesub("count=".@mkdir_Tree_file);
}
# ============================================================================
sub mkdir_Tree_getdir
# ============================================================================
{
	local($dir) =$_[0];
	local($head)=$_[1];
	local($foot)=$_[2];
	local($stkT)=$_[3];
	local($lvl) =$_[4];
	local($file);
	local($end);
	local($i);
	local(@mkdir_Tree_dirc_w)=();
	
#tracesub("-----------------------------");
#tracesub("mkdir_Tree_getdirIN$lvl::$dir");

	push(@mkdir_Tree_dirc  ,"$lvl<>$dir<><>");
	opendir(mkdir_TreeHNDL,"$dir");
	while($file = readdir(mkdir_TreeHNDL)){
		if( $file ne "." && $file ne ".." ){
			if( -d "$dir$file" ){
				push(@mkdir_Tree_dirc_w,"$dir$file/");
				push(@mkdir_Tree_dirc  ,"$lvl<>$dir<>$file<>");
			}else{
				if( $file=~/^$head/ || $head eq "" ){
					if( $file=~/$foot$/ || $foot eq "" ){
						if( $stkT eq "" ){
							push(@mkdir_Tree_file,"$lvl<>$dir<>$file");
						}else{
							put_xvalue($stkT,$dir,get_xvalue($stkT,$dir,$file)."<>".$file);
						}
					}
				}
			}
		}
	}
	closedir(mkdir_TreeHNDL);
	
	$end = @mkdir_Tree_dirc_w;
	for($i=0;$i<$end;$i++){
		mkdir_Tree_getdir($mkdir_Tree_dirc_w[$i],$head,$foot,$stkT,$lvl+1);
	}
}
# ============================================================================
sub EMGC_SNAP
# ============================================================================
{
	local($mess)=$_[0];
	local($file)="EMGC_FILE.cgi";
	local($ww);
	
	open(EMGCfp,">>$file");
	print EMGCfp "============================================================================\n";
	print EMGCfp "=== $date ===\n";
	print EMGCfp "============================================================================\n";
	print EMGCfp "=== $date ===\n";
	print EMGCfp "$mess\n";
	print EMGCfp "----------------------------------------------------------------------------\n";
	open(EMGCin,"$trcsfile");
	while( ($buf=<EMGCin>) ){
		$buf=~s/\n//g;
		$buf=~s/\xd//g;
		print EMGCfp "$buf\n";
	}
	close(EMGCin);
	#
	print EMGCfp "--ENV SNAP------------------------------------------------------------------\n";
	foreach(sort keys %ENV){
		$ww=$ENV{$_};
		print EMGCfp "$_ : $ww\n";
	}
	#
	close(EMGCfp);
}
# ============================================================================
sub fileIO_CSSMARGE
# ============================================================================
{
	local($src_file)=$_[0];
	local($dst_file)=$_[1];
	local($i,$j);

	local($class_name);
	local($class_type);
	local($class_ankr);
	local($CNTMAX    );
	local($smp       );
	local($mrk       );
	local($val       );

	local($class_name_src);
	local($class_type_src);
	local($class_ankr_src);
	local($CNTMAX_src    );
	local($smp_src       );
	local($mrk_src       );
	local($val_src       );
	
	local($class_name_dst);
	local($class_type_dst);
	local($class_ankr_dst);
	local($CNTMAX_dst    );
	local($smp_dst       );
	local($mrk_dst       );
	local($val_dst       );
	
	local($src_at    )="SRC";
	local($dst_at    )="DST";

	local($debug     )=0;	# DEBUG

	%class_name_list =();
	%class_name_type =();
	%class_name_ankr =();
	%class_name_mess =();
	%class_name_table=();
	
	#-------------------------------------------------------------------------------------------
	# SRC READ
	#-------------------------------------------------------------------------------------------
if( $src_file eq "template_dock/YUZU_afRED/navi.css" ){ $debug=1; }
	tracesub("#--------------------------------------------------------------------------------------------");
	tracesub("fileIO_CSSMARGE IN:$src_file");
	fileIO_CSSread("$src_at",$src_file);
	if( $debug==1 ){
		for($i=0;$i<$class_name_list_count{"$src_at"};$i++){
			$src_simbol     = "$src_at"."_".$i;
			$class_name_src = $class_name_list{ $src_simbol };	# class name
			$class_type_src = $class_name_type{ $src_simbol };	# TAG / USER CLASS
			$class_ankr_src = $class_name_ankr{ $src_simbol };	# DEF / HOV / VIS
			$class_mess_src = $class_name_mess{ $src_simbol };	# DEF / HOV / VIS
			$CNTMAX_src     = $class_name_table{$src_simbol."_".$class_name_src."CNTMAX" };
			if( $debug!=0 ){
				tracesub("src read:$i)$class_name_src class_ankr=$class_ankr_src class_type=$class_type_src CNTMAX=$CNTMAX_src class_mess=$class_mess_src");
			}
			for($j=0;$j<$class_name_table{   $src_simbol."_".$class_name_src."CNTMAX" };$j++){
				$smp_src = $class_name_table{$src_simbol."_".$class_name_src."SMP".$j };
				$mrk_src = $class_name_table{$src_simbol."_".$class_name_src."MRK".$j };
				$val_src = $class_name_table{$src_simbol."_".$class_name_src."VAL".$j };
				tracesub("    $j)mrk=$mrk_src smp=$smp_src val=$val_src");
			}
		}
	}
	
	#-------------------------------------------------------------------------------------------
	# DST READ
	#-------------------------------------------------------------------------------------------
	tracesub("#--------------------------------------------------------------------------------------------");
	tracesub("fileIO_CSSMARGE OT:$dst_file");
	fileIO_CSSread("$dst_at",$dst_file);
	if( $debug==1 ){
		for($i=0;$i<$class_name_list_count{ "$dst_at"};$i++){
			$dst_simbol     = "$dst_at"."_".$i;
			$class_name_dst = $class_name_list{ $dst_simbol };	# class name
			$class_type_dst = $class_name_type{ $dst_simbol };	# TAG / USER CLASS
			$class_ankr_dst = $class_name_ankr{ $dst_simbol };	# DEF / HOV / VIS
			$class_mess_dst = $class_name_mess{ $dst_simbol };	# DEF / HOV / VIS
			$CNTMAX_dst     = $class_name_table{$dst_simbol."_".$class_name_dst."CNTMAX" };
			if( $debug!=0 ){
				tracesub("dst read:$i)$class_name_dst class_ankr=$class_ankr_dst class_type=$class_type_dst CNTMAX=$CNTMAX_dst class_mess=$class_mess_dst");
			}
			for($j=0;$j<$class_name_table{   $dst_simbol."_".$class_name_dst."CNTMAX" };$j++){
				$smp_dst = $class_name_table{$dst_simbol."_".$class_name_dst."SMP".$j };
				$mrk_dst = $class_name_table{$dst_simbol."_".$class_name_dst."MRK".$j };
				$val_dst = $class_name_table{$dst_simbol."_".$class_name_dst."VAL".$j };
				tracesub("    $j)mrk=$mrk_dst smp=$smp_dst val=$val_dst");
			}
		}
	}
	#-------------------------------------------------------------------------------------------
	# DATA MERGE
	#-------------------------------------------------------------------------------------------
	for($i=0;$i<$class_name_list_count{"$src_at"};$i++){
		$src_simbol     = "$src_at"."_".$i;
		$class_name_src = $class_name_list{ $src_simbol };	# class name
		$src_type       = $class_name_type{$src_simbol};
		$src_ankr       = $class_name_ankr{$src_simbol};
		$class_name_list_copyflag{ $src_simbol."_".$src_type."_".$src_ankr } = "";
		for($j=0;$j<$class_name_list_count{ "$dst_at"};$j++){
			$dst_simbol     = "$dst_at"."_".$j;
			$class_name_dst = $class_name_list{ $dst_simbol };	# class name
			
			if( $class_name_src eq $class_name_dst                               &&
				$class_name_type{ $dst_simbol } eq $class_name_type{$src_simbol} &&
				$class_name_ankr{ $dst_simbol } eq $class_name_ankr{$src_simbol} ){
				
				$class_name_list_copyflag{ $src_simbol."_".$src_type."_".$src_ankr } = "1";
				
				$class_name_list{ $dst_simbol }=$class_name_list{$src_simbol};
				$class_name_type{ $dst_simbol }=$class_name_type{$src_simbol};
				$class_name_ankr{ $dst_simbol }=$class_name_ankr{$src_simbol};
				$class_name_mess{ $dst_simbol }=$class_name_mess{$src_simbol};
				$class_name_table{$dst_simbol."_".$class_name_dst."CNTMAX"}=
														$class_name_table{$src_simbol."_".$class_name_src."CNTMAX"};
				for($k=0;$k<$class_name_table{$src_simbol."_".$class_name_src."CNTMAX"};$k++){
					$class_name_table{$dst_simbol."_".$class_name_dst."SMP".$k }=
														$class_name_table{$src_simbol."_".$class_name_src."SMP".$k };
					$class_name_table{$dst_simbol."_".$class_name_dst."MRK".$k }=
														$class_name_table{$src_simbol."_".$class_name_src."MRK".$k };
					$class_name_table{$dst_simbol."_".$class_name_dst."VAL".$k }=
														$class_name_table{$src_simbol."_".$class_name_src."VAL".$k };
				}
			}
		}
	}
	#-------------------------------------------------------------------------------------------
	# DATA ADD
	#-------------------------------------------------------------------------------------------
	$dst_cnt = $class_name_list_count{ "$dst_at"};
	for($i=0;$i<$class_name_list_count{"$src_at"};$i++){
		$src_simbol     = "$src_at"."_".$i;
		$class_name_src = $class_name_list{$src_simbol};
		$src_type       = $class_name_type{$src_simbol};
		$src_ankr       = $class_name_ankr{$src_simbol};
		if( $debug!=0 ){
			tracesub("ADD:$i)$class_name_src copyflag=".$class_name_list_copyflag{ $src_simbol });
		}
		if( $class_name_list_copyflag{ $src_simbol."_".$src_type."_".$src_ankr } eq "" ){
			$dst_simbol     = "$dst_at"."_".$dst_cnt;
			$class_name_dst = $class_name_src;
			$class_name_list{ $dst_simbol}=$class_name_dst;
			$class_name_type{ $dst_simbol}=$class_name_type{$src_simbol};
			$class_name_ankr{ $dst_simbol}=$class_name_ankr{$src_simbol};
			$class_name_mess{ $dst_simbol}=$class_name_mess{$src_simbol};
			$class_name_table{$dst_simbol."_".$class_name_dst."CNTMAX"}=
													$class_name_table{$src_simbol."_".$class_name_src."CNTMAX"};
			for($k=0;$k<$class_name_table{$src_simbol."_".$class_name_src."CNTMAX"};$k++){
				$class_name_table{$dst_simbol."_".$class_name_dst."SMP".$k }=
													$class_name_table{$src_simbol."_".$class_name_src."SMP".$k };
				$class_name_table{$dst_simbol."_".$class_name_dst."MRK".$k }=
													$class_name_table{$src_simbol."_".$class_name_src."MRK".$k };
				$class_name_table{$dst_simbol."_".$class_name_dst."VAL".$k }=
													$class_name_table{$src_simbol."_".$class_name_src."VAL".$k };
			}
			$dst_cnt++;
		}
	}
	$class_name_list_count{ "$dst_at"}=$dst_cnt;
	#-------------------------------------------------------------------------------------------
	# SNAP
	#-------------------------------------------------------------------------------------------
	tracesub("#--------------------------------------------------------------------------------------------");
	tracesub("SNAP $dst_file");
	if( $debug==1 ){
		for($i=0;$i<$class_name_list_count{ "$dst_at"};$i++){
			$dst_simbol     = "$dst_at"."_".$i;
			$class_name_dst = $class_name_list{ $dst_simbol };	# class name
			$class_type_dst = $class_name_type{ $dst_simbol };	# TAG / USER CLASS
			$class_ankr_dst = $class_name_ankr{ $dst_simbol };	# DEF / HOV / VIS
			$class_mess_dst = $class_name_mess{ $dst_simbol };	# DEF / HOV / VIS
			$CNTMAX_dst     = $class_name_table{$dst_simbol."_".$class_name_dst."CNTMAX" };
			if( $debug!=0 ){
				tracesub("$i)$class_name_dst class_ankr=$class_ankr_dst class_type=$class_type_dst CNTMAX=$CNTMAX_dst class_mess=$class_mess_dst");
			}
			for($j=0;$j<$class_name_table{   $dst_simbol."_".$class_name_dst."CNTMAX" };$j++){
				$smp_dst = $class_name_table{$dst_simbol."_".$class_name_dst."SMP".$j };
				$mrk_dst = $class_name_table{$dst_simbol."_".$class_name_dst."MRK".$j };
				$val_dst = $class_name_table{$dst_simbol."_".$class_name_dst."VAL".$j };
				tracesub("    $j)mrk=$mrk_dst smp=$smp_dst val=$val_dst");
			}
		}
	}
	#-------------------------------------------------------------------------------------------
	# OUT FILE
	#-------------------------------------------------------------------------------------------
	open(OT,">$dst_file");
	#print OT "#CssFormatOK\n";
	#print OT "#/---\n";
	for($i=0;$i<$class_name_list_count{ "$dst_at"};$i++){
		$dst_simbol     = "$dst_at"."_".$i;
		$class_name_dst = $class_name_list{ $dst_simbol };	# class name
		$class_type_dst = $class_name_type{ $dst_simbol };	# TAG / USER CLASS
		$class_ankr_dst = $class_name_ankr{ $dst_simbol };	# DEF / HOV / VIS
		$class_mess_dst = $class_name_mess{ $dst_simbol };	# DEF / HOV / VIS
		
		if(     $class_ankr_dst eq "DEFAULT" ){
			if( $class_type_dst eq "TAG" ){
				print OT $class_name_dst."{\n";
			}else{
				print OT ".".$class_name_dst."{\n";
			}
		}elsif( $class_ankr_dst eq "ANKER"   ){
			print OT "A.".$class_name_dst."{\n";
			
		}elsif( $class_ankr_dst eq "VISITED" ){
			print OT "A:VISITED.".$class_name_dst."{\n";
			
		}elsif( $class_ankr_dst eq "HOVER"   ){
			print OT "A:HOVER.".$class_name_dst."{\n";
		}
		$CNTMAX_dst     = $class_name_table{$dst_simbol."_".$class_name_dst."CNTMAX" };
		for($j=0;$j<$class_name_table{   $dst_simbol."_".$class_name_dst."CNTMAX" };$j++){
			$smp_dst = $class_name_table{$dst_simbol."_".$class_name_dst."SMP".$j };
			$mrk_dst = $class_name_table{$dst_simbol."_".$class_name_dst."MRK".$j };
			$val_dst = $class_name_table{$dst_simbol."_".$class_name_dst."VAL".$j };
			print OT "    $smp_dst : $val_dst;\n";
		}
		print OT "}\n";
	}
	close(OT);
}
# ============================================================================
sub fileIO_CSSread
# ============================================================================
{
	local($data_at)=$_[0];
	local($file   )=$_[1];
	local($buf  );
	local($spbuf);
	local($p);
	local($strlen);
	local($class_name_list_count)=0;
	local($class_name);
	local($cnt)=0;
	local($mess)="";
	#--------------------------------------------------------------------------------------------
	# Xibv̎d
	#--------------------------------------------------------------------------------------------
	#local($i,$j);
	#local($class_name);
	#local($class_type);
	#local($class_ankr);
	#local($CNTMAX    );
	#local($smp       );
	#local($mrk       );
	#local($val       );
	#
	#for($i=0;$i<$class_name_list_count{"SRC"};$i++){
	#	$class_name = $class_name_list{ "SRC"."_".$i};	# class name
	#	$class_type = $class_name_type{ "SRC"."_".$i};	# TAG / USER CLASS
	#	$class_ankr = $class_name_ankr{ "SRC"."_".$i};	# DEF / HOV / VIS
	#	$class_mess = $class_name_mess{ "SRC"."_".$i};	# DEF / HOV / VIS
	#	$CNTMAX     = $class_name_table{"SRC"."_".$class_name."CNTMAX" };
	#	tracesub("$i)$class_name class_ankr=$class_ankr class_type=$class_type CNTMAX=$CNTMAX class_mess=$class_mess");
	#	for($j=0;$j<$class_name_table{  "SRC"."_".$class_name."CNTMAX" };$j++){
	#		$smp = $class_name_table{   "SRC"."_".$class_name."SMP".$j };
	#		$mrk = $class_name_table{   "SRC"."_".$class_name."MRK".$j };
	#		$val = $class_name_table{   "SRC"."_".$class_name."VAL".$j };
	#		tracesub("    $j)mrk=$mrk smp=$smp val=$val");
	#	}
	#}
	#--------------------------------------------------------------------------------------------

	#-----------------------
	# t@C`
	#-----------------------
	fileIO_Remake_CSS($file);
	
	#-----------------------
	# ǂݍ
	#-----------------------
	open(IN,$file);
	while( ($buf=<IN>) ){
		$buf=~s/\n//g;
		$buf=~s/\xd//g;
		$spbuf = $buf;
		$spbuf=~s/\t+//g;
		if( $spbuf eq "" ){
			
		}elsif( substr($spbuf,0,1) eq "#" ){
			if( substr($spbuf,0,5) eq "#/---" ){
				$mess ="";
			}else{
				$mess.=$buf;
			}

		}else{
			$mess="";
			if( substr($spbuf,0,2) eq "A." ){
				$spbuf = substr($spbuf,2);
				if( index($spbuf,".")==-1 ){
					$p=index($spbuf,"{");
					if( $p!=-1 ){
						$str_len          =length($spbuf);
						$class_name       =substr($spbuf,0,$str_len-2-$p);
						$class_table_name =$data_at."_".$class_name_list_count ;
						$class_name_list{  $class_table_name } = $class_name;
						$class_name_type{  $class_table_name } = "";
						$class_name_ankr{  $class_table_name } = "ANKER";
						$class_name_mess{  $class_table_name } = $mess;
						# DECORD SIMPLE BLOCK
						$cnt=0;
						$class_name_table{ $class_table_name."_".$class_name."CNTMAX"   } = $cnt;
						$cnt=fileIO_BLOCK_DEC($class_table_name,$class_name,"ANK",$cnt);
						$class_name_list_count++;
					}
				}
				
			}elsif( index($spbuf,"A:VISITED.".$class_name)!=-1 ){
				$class_table_name =$data_at."_".$class_name_list_count ;
				$class_name_list{  $class_table_name } = $class_name;
				$class_name_type{  $class_table_name } = "";
				$class_name_ankr{  $class_table_name } = "VISITED";
				$class_name_mess{  $class_table_name } = $mess;
				# DECORD SIMPLE BLOCK
				$cnt=0;
				$class_name_table{ $class_table_name."_".$class_name."CNTMAX"   } = $cnt;
				$cnt=fileIO_BLOCK_DEC($class_table_name,$class_name,"VIS",$cnt);
				$class_name_list_count++;
				
			}elsif( index($spbuf,"A:HOVER.".$class_name)!=-1 ){
				$class_table_name =$data_at."_".$class_name_list_count ;
				$class_name_list{  $class_table_name } = $class_name;
				$class_name_type{  $class_table_name } = "";
				$class_name_ankr{  $class_table_name } = "HOVER";
				$class_name_mess{  $class_table_name } = $mess;
				# DECORD SIMPLE BLOCK
				$cnt=0;
				$class_name_table{ $class_table_name."_".$class_name."CNTMAX"   } = $cnt;
				$cnt=fileIO_BLOCK_DEC($class_table_name,$class_name,"HOV",$cnt);
				$class_name_list_count++;
				
#			}elsif( index($spbuf,":VISITED")!=-1 && index($spbuf,"A:VISITED.".$class_name)==-1){
#				$class_name_table{ $class_table_name."_".$class_name."SMP".$cnt } = "TYPE";
#				$class_name_table{ $class_table_name."_".$class_name."MRK".$cnt } = "VIS";
#				$class_name_table{ $class_table_name."_".$class_name."VAL".$cnt } = "ANK";
#				$cnt++;
#				$cnt=fileIO_BLOCK_DEC($class_name,"VIS",$cnt);
#				
#			}elsif( index($spbuf,":HOVER")!=-1   && index($spbuf,"A:HOVER.".$class_name)==-1 ){
#				$class_name_table{ $class_table_name."_".$class_name."SMP".$cnt } = "TYPE";
#				$class_name_table{ $class_table_name."_".$class_name."MRK".$cnt } = "HOV";
#				$class_name_table{ $class_table_name."_".$class_name."VAL".$cnt } = "ANK";
#				$cnt++;
#				$cnt=fileIO_BLOCK_DEC($class_table_name,$class_name,"HOV",$cnt);
#			
			}elsif( substr($spbuf,0,1) eq "." ){
				$p=index($spbuf,"{");
				if( $p!=-1 ){
					$str_len          =length($spbuf);
					$class_name       =substr($spbuf,1,$str_len-2-$p);
					$class_table_name =$data_at."_".$class_name_list_count ;
					$class_name_list{  $class_table_name } = $class_name;
					$class_name_type{  $class_table_name } = "";
					$class_name_ankr{  $class_table_name } = "DEFAULT";
					$class_name_mess{  $class_table_name } = $mess;
					# DECORD SIMPLE BLOCK
					$cnt=0;
					$class_name_table{ $class_table_name."_".$class_name."CNTMAX"   } = $cnt;
					$cnt=fileIO_BLOCK_DEC($class_table_name,$class_name,"DEF",$cnt);
					$class_name_list_count++;
				}
			}else{
				$p=index($spbuf,"{");
				if( $p!=-1 ){
					$str_len          =length($spbuf);
					$class_name       =substr($spbuf,0,$str_len-2-$p);
					$class_table_name =$data_at."_".$class_name_list_count ;
					$class_name_list{  $class_table_name } = $class_name;
					$class_name_type{  $class_table_name } = "TAG";
					$class_name_ankr{  $class_table_name } = "DEFAULT";
					$class_name_mess{  $class_table_name } = $mess;
					# DECORD SIMPLE BLOCK
					$cnt=0;
					$class_name_table{ $class_table_name."_".$class_name."CNTMAX"   } = $cnt;
					$cnt=fileIO_BLOCK_DEC($class_table_name,$class_name,"DEF",$cnt);
					$class_name_list_count++;
				}
			}
		}
	}
	close(IN);
	$class_name_list_count{ $data_at } = $class_name_list_count;
}
# ============================================================================
sub fileIO_CSS_Sfield
# ============================================================================
{
	local($class_table_name)=$_[0];
	local($class_name      )=$_[1];
	local($class_mark      )=$_[2];
	local($class_smbl      )=$_[3];
	local($smp);
	local($mrk);
	local($val);
	local($j);
	
	for($j=0;$j<$class_name_table{ $class_table_name."_".$class_name."CNTMAX"   };$j++){
		$smp = $class_name_table{  $class_table_name."_".$class_name."SMP".$j };
		$mrk = $class_name_table{  $class_table_name."_".$class_name."MRK".$j };
		$val = $class_name_table{  $class_table_name."_".$class_name."VAL".$j };
		if( $mrk eq $class_mark ){
			if( $smp eq $class_smbl ){
				return($val);
			}
		}
	}
	return("");
}
# ============================================================================
sub fileIO_BLOCK_DEC
# ============================================================================
{
	local($class_table_name)=$_[0];
	local($class_name      )=$_[1];
	local($class_mark      )=$_[2];
	local($cnt             )=$_[3];
	local($buf);
	local($spbuf);
	
#tracesub("--------------BLOCK_DEC:IN:class=$class_name MARK=$class_mark");
	# DECORD SIMPLE BLOCK
	while( ($buf=<IN>) ){
		$buf   =~s/\n//g;
		$buf   =~s/\xd//g;
		$spbuf = $buf;
		$spbuf =~s/\t//g;
		if( $spbuf eq "}" ){ 
			last; 
		}
		if( index($spbuf,":")!=-1 ){
			($css_name,$css_val)=split(/:/,$spbuf);
			($css_val)=split(/;/,$css_val);
			$css_name=~s/\s//g;
			$css_val =~s/^\s+//g;
			$css_val =~s/\s+$//g;
			$class_name_table{ $class_table_name."_".$class_name."SMP".$cnt } = $css_name;
			$class_name_table{ $class_table_name."_".$class_name."MRK".$cnt } = $class_mark;
			$class_name_table{ $class_table_name."_".$class_name."VAL".$cnt } = $css_val;
			$cnt++;
			$class_name_table{ $class_table_name."_".$class_name."CNTMAX"   } = $cnt;
		}
	}
	return($cnt);
}
# ============================================================================
sub fileIO_Remake_CSS
# ============================================================================
{
	local($file)    =$_[0];
	local($tempfile)=$file.".css";
	local($eflag)=0;
	local($CMSP)=": ";
	local($SPMK)="<sp>";
	local($SPDT)=" ";
	local($mastremake)=1;
	local($readcount)=0;
	local($buf);
	
	open(IN,"$file");
	$buf=<IN>;
	if( $buf=~/^\#CssFormatOK/ ){
		$mastremake=0;
	}
	close(IN);
	if( $mastremake==0 ){
		return;
	}
	
	$CSS_buffer="";
	open(IN,"$file");
	open(OT,">>$tempfile");
	while($eflag==0){
		($buf,$eflag)=fileIO_CSS_getbuf();
		if( $eflag==1 ){
			last;
		}
		if( index($buf,"{")!=-1 || index($buf,"}")!=-1 ){
			print OT "$buf\n";
		}else{
			$buf=~s/\t//g;
			$buf=~s/\:/$CMSP/g;
			$buf=~s/$SPMK/$SPDT/g;
			print OT "\t$buf\n";
		}
	}
	close(IN);
	close(OT);
	
	system("mv", $tempfile, $file);
	unlink($tempfile);
}
# ============================================================================
sub fileIO_CSS_getbuf
# ============================================================================
{
	local($buf)="";
	local($ch,$eflag);
	
	($ch,$eflag)=fileIO_CSS_getch();
	while($eflag==0){
		if( $ch eq "}" ){
			if( $buf ne "" ){
				$buf="\t$buf;\n}";
			}
			else{
				$buf.=$ch;
			}
			last;
		}
		#if( $ch ne " "){
			$buf.=$ch;
		#}
		if( $ch eq "{" ){
			last;
		}
		if( $ch eq ";" ){
			last;
		}
		($ch,$eflag)=fileIO_CSS_getch();
	}
	return($buf,$eflag);
}
# ============================================================================
sub fileIO_CSS_getch
# ============================================================================
{
	local($ch);
	local($buf);
	
	while( ($CSS_buffer eq "") ){
		if( ($buf=<IN>) ){
			$CSS_buffer = $buf;
			$CSS_buffer =~s/\n//g;
			$CSS_buffer =~s/\xd//g;
			
		}else{
			return("",1);
		}
	}
	$ch         = substr($CSS_buffer,0,1);
	$CSS_buffer = substr($CSS_buffer,1);
	
	return($ch,0);
}
1;
