# ============================================================================
sub in_GOOGLE_MAPS
# ============================================================================
{
	local($xfile) =$_[0];
	local($mfile) =$_[1];
	local($bfile) =$_[2];
	local($apikey)=$_[3];
	local($title) =$_[4];
	local($width) =$_[5];
	local($height)=$_[6];
	local($zoom)  =$_[7];
	local($x_lat) =$_[8];
	local($x_lon) =$_[9];
	local($addpth)=$_[10];
	local($xdir,$xfil,$xext);
	local($fwidth) ;
	local($fheight);
	local($ret)="";
	#-----------------------------
	if( $width eq "" ){
		$width  = "300";
	}
	if( $height eq "" ){
		$height = "300";
	}
	if( $zoom eq "" ){
		$zoom = "16";
	}
	$fwidth  = $width  + 8;
	$fheight = $height + 8;
	if( $width  =~/px$/ ){}else{ $width.="px"; }
	if( $height =~/px$/ ){}else{ $height.="px"; }
	if( $fwidth =~/px$/ ){}else{ $fwidth.="px"; }
	if( $fheight=~/px$/ ){}else{ $fheight.="px"; }
	#-----------------------------
	if( $x_lat eq "" || $x_lon eq "" ){
		tracesub("in_GOOGLE_MAPS LAT or LON Data Non.");
		return("");
	}
	($xdir,$xfil,$xext)=fnsplit($xfile);
	$db_file = $xfil.$xext;
	($xdir,$xfil,$xext)=fnsplit($mfile);
	$mp_file = $xfil.$xext;
	($xdir,$xfil,$xext)=fnsplit($bfile);
	$bg_file = $xfil.$xext;
	#-----------------------------
	$POS_DESC = strcode_conv("sjis2utf8",$title);
	open(MAPF,">$xfile");
	print MAPF <<"EOM";
<?xml version="1.0" encoding="UTF-8" ?>
<?xml-stylesheet type="text/xsl" href="place.xsl"?>
<places>
<place latitude="$x_lat" longitude=\"$x_lon\">
<title>$POS_DESC</title>
<description>$POS_DESC</description>
</place>
</places>
EOM
	close(MAPS);
	
	in_GOOGLE_MAPS_HTML($POS_DESC,$mfile,"$addpth$db_file",$width ,$height,$zoom,"small");
	in_GOOGLE_MAPS_HTML($POS_DESC,$bfile,"$addpth$db_file","800px","800px",$zoom,"big");
	
	$ret = <<"EOM";
	<iframe src="$addpth$mp_file" width="$fwidth" height="$fheight"></iframe>
EOM
#	$ret = <<"EOM";
#	<iframe src="$mp_file" width="$fwidth" height="$fheight"></iframe>
#	<a href="$bg_file" target="_blank">{MAP}</a>
#EOM

	return($ret);
}
# ============================================================================
sub in_GOOGLE_MAPS_HTML
# ============================================================================
{
	local($title)  =$_[0];
	local($file)   =$_[1];
	local($db_file)=$_[2];
	local($width)  =$_[3];
	local($height) =$_[4];
	local($zoom)   =$_[5];
	local($mapsize)=$_[6];
	local($utftitle);
	local($urls);
	
	$urls = "<a href=\"".get_xvalue("ENV","ENV_SHOPURLS")."\">";
	$urls.= "<font size=\"1\" color=\"#333333\">";
	$urls.= get_xvalue("ENV","ENV_NAME");
	$urls.= "</font>";
	$urls.= "</a>";
	
	
	#$zoom = 17-$zoom;
	
	$urls = strcode_conv("sjis2utf8",$urls);
	
	open(MAPF,">$file");
	print MAPF <<"EOM";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>$title</title>
<script src="http://maps.google.com/maps?file=api&v=1&key=$apikey" type="text/javascript"></script>
</head>
<body leftmargin="0" topmargin="0">
<center>
EOM
	if( $mapsize eq "big" ){
print MAPF <<"EOM";
$POS_DESC<br><hr>
EOM
	}
print MAPF <<"EOM";
<div id="map" style="width: $width; height: $height"><img src="img/map_dummy.gif" /></div>
<script type="text/javascript">
//<![CDATA[
var map = new GMap(document.getElementById("map"));
map.addControl(new GMapTypeControl());
map.addControl(new GLargeMapControl());
//map.setMapType(G_HYBRID_MAP);
//map.setMapType(G_SATELLITE_MAP);
map.setMapType(G_NORMAL_MAP);
function addMarker(point, html, i) {
	if( html != "" ) {
			var marker = new GMarker(point);
		GEvent.addListener(marker, "click", function() {
			marker.openInfoWindowHtml(html);
		});
	
		map.addOverlay(marker);
	
		return marker;
	}
}
	var request = GXmlHttp.create();
	request.open("GET", "$db_file", true);
	request.send(null);
	request.onreadystatechange = function() {
		if (request.readyState == 4) {
			var xmlDoc = request.responseXML;
			var places = xmlDoc.documentElement.getElementsByTagName("place");
			for( var i=0; i < places.length ; i++ ) {
				var latitude  = parseFloat(places[i].getAttribute("latitude") );
				var longitude = parseFloat(places[i].getAttribute("longitude") );
				var point     = new GPoint( longitude, latitude );
				var html = "<div style='width:150px'>";
				if( places[i].getElementsByTagName("title").length != 0 ) {
					html += "<b>";
					var title = places[i].getElementsByTagName("title")[0].firstChild.nodeValue;
					if( places[i].getElementsByTagName("link").length != 0 ) {
						var link = places[i].getElementsByTagName("link")[0].firstChild.nodeValue;
						html += "<a href='" + link + "'>" + title + "</a>";
					}
					else html += title;
					html += "</b><br>";
				}
				if( places[i].getElementsByTagName("description").length != 0 ) {
					html += "<font size='-1'>";
					html += places[i].getElementsByTagName("description")[0].firstChild.nodeValue;
					html += "</font><br>";
				}
				if( places[i].getElementsByTagName("image").length != 0 ) {
					html += "<img src='";
					html += places[i].getElementsByTagName("image")[0].firstChild.nodeValue;
					html += "'>";
				}
				html += "</div>";
				if( i == 0 ){
					map.centerAndZoom( point, $zoom );
				}
				addMarker( point, html ,i );
			}
		}
	}
//]]>
</script>
EOM
	if( $mapsize eq "big" ){
print MAPF <<"EOM";
<hr>
$urls
EOM
	}
print MAPF <<"EOM";
</center>
</body>
</html>
EOM
}
1;
